
// *****************************************************************************
//
// source:    AC_ECAL_PRE_init.C
//
// type:      source code
//
// created:    8 Dec 2000
//
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    AC_ECAL_PRE_init, AC_ECAL_PRE_evnt
//
// called by: AC_init, AC_evnt
//
// hints:     see $HBROOT/ARTE/dev/include/dq/DQ.h for COMP_XYZ and LVL_ABC
//            steered by /AC/SUBD FLT ON
//
// changes:
//  8 Dec 2000 (AG) creation
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "farm/farm.hh"
#include "alca/AC.h"
#include "alca/AC_ECAL_PRE.hh"

// externals
extern int FADEB; // debug flag set by runargs=-debug

//
// program code
//
int
AC_ECAL_PRE_init()
{
  // show up
  ARTE_mark( "AC_ECAL_PRE_init 0", 0 );
  cout << "AC_ECAL_PRE_init" << endl;

  // book histogram
  //rhp_hbook1( AC_ID( COMP_FLT, LVL_HIT, 1 ), "ECAL_PRE: txt", 50, 0., 1. );

  ARTE_mark( "AC_ECAL_PRE_init 1", 0 );
  return 0;
}

//
// program code
//
int
AC_ECAL_PRE_evnt()
{
  // show up
  ARTE_mark( "AC_ECAL_PRE_evnt 0", 0 );

  // fill histogram
  //rhp_hf1( AC_ID( COMP_FLT, LVL_HIT, 1 ), 1, 1 );

  ARTE_mark( "AC_ECAL_PRE_evnt 1", 0 );
  return 0;
}
