/* TAChaGEDE 

   pupose: change GEDE -- preliminary
   input:  NEDE tables 
   output: GEDE tables

   by Dirk Kruecker 27.1.99
*/
#include <stdio.h>
#include <string.h>

#include <arte/Arte.h>
#include "arte/ArteFlag.h"
#include <arte/ArteUtil.h>
#include <auto/GEDE.h>
#include <auto/NEDE.h>

#include "ledaC.h"
#include "wax/otr_db.h"

void TACalAliP(LedaTableRow(OTR_nede)*,LedaTableRow(OTR_align)*,float[9],float[3]);


int TAChaGEDE(char * name, float dx, float dy, float dz,
                           float da, float db, float dc, int prtflg){


  int   i,changed;
  float deltax,deltay,deltaz;
  float trans[3],Grot[9];

  int inede;
  NEDE * pn;
  GEDE * pg;
  
  LedaTableRow(OTR_nede)  nedero;
  LedaTableRow(OTR_align) alignro;
  LedaTableRow(OTR_nede)  *nederow=&nedero;
  LedaTableRow(OTR_align) *alignrow=&alignro;

  alignrow->ang[0]=-da;
  alignrow->ang[1]=-db;
  alignrow->ang[2]=-dc; 

  alignrow->delt[0]=-dx;
  alignrow->delt[1]=-dy;
  alignrow->delt[2]=-dz;

  changed = 0;  
  for(inede=1;inede<=NNEDE();inede++) {
     pn = &NEDE(inede);
     if (strncmp(pn->hwc,name,11)) continue;
     changed=1;   

/* print each moduls and its offset */
     if(prtflg) printf("%s %f %f %f %f %f %f \n",name
                                       ,alignrow->delt[0]
                                       ,alignrow->delt[1]
                                       ,alignrow->delt[2]
                                       ,alignrow->ang[0]
                                       ,alignrow->ang[1]
                                       ,alignrow->ang[2] );

/* fill part of nedero which is needed in TACalAliP - because this is a dummy */

          for(i=0;i<9;i++) {
             nederow->rot[i]=pn->rot[i];
          };

          nederow->sxmn = pn->sxmn;
          nederow->sxmx = pn->sxmx;
          nederow->symn = pn->symn;
          nederow->symx = pn->symx;
          nederow->zmin = pn->zmin;
          nederow->zmax = pn->zmax;

/* calculate offsets and new rot */

          TACalAliP(nederow,alignrow,Grot,trans);


/* update GEDE - no other alignment ! */
/* inede=igede is this always true ? */
	  pg = &GEDE(inede);
     
          for(i=0;i<9;i++) {
             pg->rot[i] = Grot[i];
          };

          deltax=trans[0];
	  deltay=trans[1];
	  deltaz=trans[2];    

          for(i=0;i<pn->nsl;i++) {
             pg->xfw[i] = pn->xfw[i] + deltax;
             pg->zfw[i] = pn->zfw[i] + deltaz;
             pg->y1w[i] = pn->y1w[i] + deltay;
             pg->y2w[i] = pn->y2w[i] + deltay;
          }
      
          pg->xmin = pn->xmin + deltax;
          pg->xmax = pn->xmax + deltax;
 
          pg->ymin = pn->ymin + deltay;
          pg->ymax = pn->ymax + deltay;
 
          pg->zmin = pn->zmin + deltaz;
          pg->zmax = pn->zmax + deltaz;
 
          pg->sxmn = pn->sxmn + deltax;
          pg->sxmx = pn->sxmx + deltax;
 
          pg->symn = pn->symn + deltay;
          pg->symx = pn->symx + deltay;

  }    /* nede loop */
  if(changed){
      return 1;
  } else {
      printf("TAChaGEDE: Error\n"); 
      return 0;
  }
}
