
// ********************************************************************
//
//  Routine:      acwrite_
//  Author:       T.Oest
//
//  Description:  interface routine for alignment/calibration
//                and data quality
//
//  Modification:
//   -- data quality added                            27/09/99 T.Oest
//   -- calibartion & alignment added                 19 Nov 1999 (AG)
//   -- AC_init() is moved to acinit                  22 Nov 1999 (AG)
//   -- use ARTE_mark()                               25 Apr 2000 (AG)
//   -- if online & L4RecoMask=0 do not run AC_evnt   10 Oct 2001 (JH)
//
// ********************************************************************

// standard includes
#include <iostream.h>

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"

// externals
int extern L4RecoMask;  // online reconstruction reco mask

// prototypes
int DQ_evnt();
int AC_evnt();

//*********************************************************************
// function
//*********************************************************************
extern "C" void
acwrite_()
{ 
  // show up
  //cout << "acwrite_()" << endl;

  // inits
  int rc = 0;
  
  // call the data quality routine
  ARTE_mark( "DQ_evnt", 0 );
  rc = DQ_evnt();

  // If online but L4RecoMask is 0 don't do AC 
  if(!L4RecoMask) return;

  // alignment/calibration interface
  ARTE_mark( "AC_evnt", 0 );
  rc = AC_evnt();
}
