*-- Author :    Hartwig Albrecht   25/10/95

      SUBROUTINE ALMCIN

************************************************************************
*
* Description: fill tables MCIN and MCME
*
* Called from: ALPYTH, ALFRIT
*
* External references:
*
* Argument in/out description
*
* Modified by U. Husemann Oct-2001
*  - Fill MC multiplicity reweighting parameters into MCIN
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MCIN.fi"
#include "auto/MCME.fi"
#include "pyth/PYSUBS.fi"

      INTEGER MODE,NTRACKS,NGLUONS,NSTRINGS,NCOLL
      REAL IMPACT,EREST
      COMMON/FRMULT/ MODE,NTRACKS,NGLUONS,NSTRINGS,NCOLL,IMPACT,
     +               EREST

#include "arte/Arte.ff"
#include "auto/MCIN.ff"
#include "auto/MCME.ff"

      IF (JMCIN .EQ. 0) THEN
      CALL MMBOOK (JMCIN, 1)
      CALL MMBOOK (JMCME, 1)
      IQ(IQMCME_EVT_L()) = NUMEVT
      IQ(IQMCME_RUN_L()) = NUMRUN
      IQ(IQMCME_EXP_L()) = NUMEXP

C further specification necessary in future:
      IQ(IQMCME_PHY_L()) = MSEL * 1000

      Q(QMCME_VLUN_L()) = LUNDVERS

C Lund random seed for this event
      IQ(IQMCME_RLUN_L(1)) = LUNDSEED(1)
      IQ(IQMCME_RLUN_L(2)) = LUNDSEED(2)
      ENDIF
C fill FRMULT common block into MCIN
      IQ(IQMCIN_WFLG_L()) = MODE
      IQ(IQMCIN_NMTA_L()) = NTRACKS
      IQ(IQMCIN_NMGL_L()) = NGLUONS
      IQ(IQMCIN_NMST_L()) = NSTRINGS
      IQ(IQMCIN_NMCO_L()) = NCOLL
      Q(QMCIN_RIMP_L())   = IMPACT
      Q(QMCIN_RERE_L())   = EREST

      END

************************************************************************
* End of ALMCIN
************************************************************************
