>NAME IOKUIP

>MENU /IOcontrol
>GUIDANCE
Input/output control.

>COMMAND HBOOK
>GUIDANCE
Declare the histogram output file for HBOOK and PAW.
For the time being, only one histogram file is forseen;
the name of the top directory is ARTE.
 Options:  -N  create new file
           -U  update existing file
           -O  overwrite old file (corresponds to option ' ' in HROPEN)
           -X  exchange format (machine independent)
Example:
 HBOOK myhist.hbook -U
>ACTION KAHBOO
>PARAMETER
+
NAME 'file name' C D=' '
OPTION 'options NUOX' C D=' '

>COMMAND IOFILE
>GUIDANCE
Associate a file to a logical unit or stream name.
This command does NOT perform any action like OPEN!
.
Typing a blank space ' ' instead of a file name indicates 
a scratch file which will be deleted when the program stops.
.
Several IOFILE commands for the same logical unit / stream name
are allowed (= concatenation).
This indicates that several files will be read/written in
sequential order.
.
An unused (= not reserved; see DECLARE command) unit number will
automatically be chosen if the stream name is not yet declared.
.
For hbook files use the command HBOOK and *not* IOFILE.
.
The options are effective for GPACK and Zebra I/O:
 -I  input
 -O  output
 -G  Gpack (default)
 -M  Gpack with shared memory access
 Zebra only for reading old files:
 -A  Zebra alpha format
 -N  Zebra native format (machine dependent)
 -X  Zebra exchange format (still machine-dependent!)
 -L  Zebra machine-independent format
Standard I/O streams:
 EV_IN        general event input: DST or MINI
 EVIN1        event input 1 for event mixing (MC only)
 EVIN2        event input 2 for event mixing
 EVIN3        event input 3 for event mixing
 EVIN4        event input 4 for event mixing
 DST_OUT      event output - DST
 MINI_OUT     event output - MINI

 I/O with Event Directories / Notebooks:
 DST_IN_NOTE  DST input with Notebook
 MINI_IN_NOTE MINI input with Notebook
 DST_IN_EDIR  DST input with Event Directory
 MINI_IN_EDIR MINI input with Event Directory
 NOTE_IN      Notebook input
 EDIR_IN      Event Directory input
 NOTE_OUT     output - Notebook

 Will be replaced by the data base pretty soon:
 GEOMIN       geometry constants input
 GEOMOUT      geometry constants output
.
The following generic names MUST NOT BE USED in the command IOFILE
because they refer to several streams (see command IOTABLE):
 INPUT OUTPUT DST MINI GEOM
There are more reserved stream names for special purposes.
Type the command LIOSTAT for a complete list!
Examples:
 IOFILE ev_in   my.dst -il
 iofile dst_out new1.dst 200. -go
 iofile dst_out new2.dst 200. -go
The parameter 200. indicates that not more than 200 Mbytes
will be written on an output file.
>ACTION KAIOFI
>PARAMETER
LOGSYM 'logical unit number or stream name' C
+
FILE   'file name' C D=' '
MAX    'output: maximum file size (Mbyte)' R D=0.
OPTION 'Zebra I/O options' C D=' '

>COMMAND IOMIX
>GUIDANCE
Mix events from up to four event input files.
The files have to be declared on EVIN1, EVIN2, EVIN3,
EVIN4 (see command IOFILE).
.
Number of interactions NEVi > 0: Poisson distribution; NEVi < 0:
exactly |NEVi| events. Examples:
 IOMIX -2         Mix exactly two events from file EVIN1
 IOMIX -1 5       Mix 1 event from EVIN1 and N events from file EVIN2
                  (N = Poisson distributed; mean = 5)
 IOMIX -1 3 -1 5  use all 4 event input files EVIN1 ... EVIN4
 IOMIX 0          disable mixing
>ACTION KAIOMI
>PARAMETER
NEV1 'events from evin1' R D=0
+
NEV2 'events from evin2' R D=0
NEV3 'events from evin3' R D=0
NEV4 'events from evin4' R D=0

>COMMAND IOTABLE
>GUIDANCE
Which table is to be written to / read from which file.
The initial I/O settings for each table are given in the Data Definition
(command DFILE which uses the same declaration of I/O streams as
described here). IOTABLE is intended to modify these settings.
.
NOTE THAT THE ORDER OF ARGUMENTS HAS BEEN CHANGED SINCE ARTE-02-04.
.
The table hierarchy (see command DSUB_OF) has been invented
in order to facilitate I/O control for sets of tables:
The full tree of
subordinate tables is affected by changing the status of their superior
table. Subordinate tables are read/written only if they and all
of their superior tables are marked for read/write.
.
The I/O files are denoted by their stream names. A slash (/)
preceding the name means disable I/O.
.
There are generic stream names which can be used in IOTABLE
and DFILE only:
 INPUT  all input files
 OUTPUT all output files
 DST    all DST input/output:  EV_IN EVIN1 EVIN2 EVIN3 EVIN4
                               DST_IN_NOTE DST_IN_EDIR DST_OUT
 MINI   all MINI input/output: EV_IN EVIN1 EVIN2 EVIN3 EVIN4
                               MINI_IN_NOTE MINI_IN_EDIR MINI_OUT
 GEOM   all geometry input/output: GEOMIN GEOMOUT
.
Examples (given for an output file; TNAM stands for an arbitrary table name):
 IOTAB DST_OUT TNAM  Table TNAM is marked for output on the stream
                     DST_OUT. The status of subordinate tables is
                     not affected. 
 IOTAB /DST_OUT TNAM Output to DST_OUT is disabled for table TNAM
                     and for ALL SUBORDINATE tables, independent
                     of their individual I/O status. A subsequent ...
 IOTAB DST_OUT TNAM  ... reenacts output for TNAM itself and, for all
                     subordinate tables, it reestablishes the previous
                     status.
 IOTAB /OUTPUT TNAM  Prevent table TNAM and all of its subordinates
                     from being written to any output file.
 IOTAB OUTPUT TNAM   Reestablish output: output depends on I/O
                     specifications given for TNAM and its subordinates.
 IOTAB INPUT TNAM    similar for input.
 IOTAB 'DST_OUT /OUT2' TNAM Several names can be enclosed in '...'.
Input files are analogous to output files. In case a table appears on
a file where it is marked for non-input: the table is skipped
unconditionally.
skip input.
>ACTION KAIOTA
>PARAMETER
IOS  'input,output (/means not)' C
NAME 'table name' C

>COMMAND IODECLARE
>GUIDANCE
Declare a logical unit and/or its stream name.
.
The stream name is a
specification of logical I/O streams and not the name of the files
themselves. In almost all commands you have the choice
to specify files either by their unit
number or by their stream name - the latter one is
easier to remember.
.
A reserved unit number will not be used by ARTE until explicitely
required by the user.  Necessary, e.g., if the unit number is used
by an auxiliary program system.
 Example:
 DECLARE 90
 A range of units can be reserved:
 DECLARE 90 99
 If only one unit number is specified (i.e. not for ranges of units),
 the stream name can be specified as 2nd parameter:
 DECLARE 7 logf
 The 3rd parameter (optional) may contain some comment:
 DECLARE 90 99 reserved
 DECLARE 90 XYZ 'used by program package XYZ'
>ACTION KADECL
>PARAMETER
LUN 'logical unit number' I R=1:99
+
LUNSYM 'logical unit number (range) or stream name' C D=' '
FILE   'file name or comment (optional)' C D=' '

>COMMAND OPEN
>GUIDANCE
Open file.
For concatenated files (see IOFILE command), this acts upon the
first file which has not yet been opened.
.
The file(s) has(have) to be declared by a preceding
IOFILE command. For a sequential file, the 2nd parameter
(RECLENGTH) has to be omitted or set to 0.
 Options: X  program stops if open not successful (batch);
             continue or stop in interactive sessions.
          B  binary (unformatted)
          F  formatted; 'F' and 'B' are mutually exlusive
          N  new: file must not yet exist
          O  old: file must exist
          ON (or neither N nor O): file may or may not exist
          AO append to an existing file
          A  append (if file exists) or create new file (if not)
Examples (note that only file names are case-sensitive):
 IOFILE SCRATCH
 OPEN SCRATCH
 iofile 66 direct.access
 OPEN   66 1024 -N
.
 IODECLARE  77 FORT77
 iofile     77 uvw
 iofile   fort77 xyz
 open     FORT77 -o ... opens uvw
 CLOSE      77
 open       77 -O   ... opens xyz
 close  FORT77
 open 77            ... warning (no more files)

>ACTION KAOPEN
>PARAMETER
LOGSYM 'logical unit number or stream name' C
+
RECLENGTH 'record length for direct access data' I D=0
OPTION 'option (combination of XBFONA)' C OPTION D=' '

>COMMAND CLOSE
>GUIDANCE
Close file.
A 2nd CLOSE goes forward to the next file in a concatenation chain
(if there is any).
>ACTION KACLOS
>PARAMETER
LOGSYM 'logical unit number or stream name' C

>COMMAND SKIP
>GUIDANCE
Skip records on input files.
.
On event input files only event records are skipped. All other types of
records will be accepted.
.
This command can be replaced by the powerful event selction tool
SELECT (q.v.).
>ACTION KASKIP
>PARAMETER
+
NSKIP 'number of records to be skipped' I D=1
LUNSYM 'logical unit number (range) or stream name' C D='EVIN1'

>COMMAND REWIND
>GUIDANCE
Rewind file; go back to a previous file.
.
The 1st REWIND rewinds to the 1st record on a file. A 2nd REWIND
and all following ones go back to the previous file in a concatenation
chain (if there is any).
>ACTION KAREWI
>PARAMETER
LOGSYM 'logical unit number or stream name' C


>Command DCACHE
>Guidance
Switch ON/OFF dCache usage for opening tape files,
	when called without parameters, reports current setting.

>Action io_dcache
