*-- Author :    Thomas Lohse   March 8, 1999

      SUBROUTINE LUINIT

************************************************************************
*
* Description: Define defaults for MC generator options and parameters 
*
* Called from: ATINIT
*
* External references:
*
* Argument in/out description
*
* Modified by U. Husemann Oct-2001
*  - set default multiplicity reweighting mode (3)
*
************************************************************************

      IMPLICIT NONE

#include "arte/luopts.fi"

c default mode in MC multiplicity tuning
      INTEGER MODE,NTRACKS,NGLUONS,NSTRINGS,NCOLL
      REAL IMPACT,EREST
      COMMON/FRMULT/MODE,NTRACKS,NGLUONS,NSTRINGS,NCOLL,IMPACT,EREST
      SAVE/FRMULT/

c initialize the MC reweigting common block
c     MODE     = 0 ! reweighting disabled
c     MODE     = 1 ! reweighting with fraction of subcollisions
c     MODE     = 2 ! reweighting with fraction of subcollisions squared
      MODE     = 3 ! reweighting with number of accepted tracks
c     MODE     = 4 ! reweighting with number of gluons
      NTRACKS  = 0
      NGLUONS  = 0
      NSTRINGS = 0
      NCOLL    = 0
      IMPACT   = 0.
      EREST    = 0.

      lunsel   = 0
      netrig   = 0
      nmtrig   = 0
      neacc    = 0
      nmuacc   = 0
      modemb   = 1
      modePsi  = 2
      modeY    = 2
      modefrag = 2
      nlept    = 0
      pt0mb    = 0.
      pt0psi   = 1.
      pt0Y     = 1.
      ptl1     = 0.
      ptl2     = 0.
      xml12    = 0.

 90   END

************************************************************************
* End of LUINIT
************************************************************************
