*-- Author :    Hartwig Albrecht   17/05/95

      INTEGER FUNCTION MMRSTAT (LUN, IL)

************************************************************************
*
* Description: is the table at link IL foreseen for input?
*
* Called from: anywhere
*
* Argument in/out description
*   LUN    in     logical unit
*   IL     in     link number
*   result        0:  input ok
*
*                 1:  table is NOT empty
*                 2:  table is a relation (io only without corresponding table)
*                 3:  io temporary switched off from this LUN
*                 4:  io temporary switched off from all LUNs
*                 5:  io permanently switched off from this lun
*                 6:  io on LUN not controlled by DD
*                -1:  wrong input parameter
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"
#include "auto/MEIO.fi"

      INTEGER LOCF, LUN, IL, IB

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEIO.ff"

      IF (LUN .LE. 0 .OR. LUN .GT. 99 .OR.
     +    IL .LE. 1 .OR. IL .GT. NARLNK)  THEN
        MMRSTAT = -1
        GO TO 90
      END IF

      IB = HMEIO_BIT(LUN)
      IF (IB .EQ. 0)  THEN
        MMRSTAT = 6
        GO TO 90
      END IF

      IF (IMEMO_FLAG(IL) .GT. 0)  THEN
        MMRSTAT = 2
        GO TO 90
      END IF

      IF (BITTEST (BMEMO_IOD(IL), IB) .EQ. 0)  THEN
        MMRSTAT = 5
        GO TO 90
      END IF

      IF (BITTEST (BMEMO_IOA(IL), IB) .EQ. 0)  THEN
        MMRSTAT = 3
        GO TO 90
      END IF

      IF (BITTEST (BMEMO_IOD(IL), 1) .EQ. 0)  THEN
        MMRSTAT = 4
        GO TO 90
      END IF

      IF (JLINK(IL) .NE. 0)  THEN
        IF (IQ(JLINK(IL)+2) .NE. 0)  THEN
          MMRSTAT = 1
          GO TO 90
        END IF
      END IF

      MMRSTAT = 0

 90   END

************************************************************************
*     End of MMRSTAT
************************************************************************
