/***********************************************************************
*
* DGGEPT
* written by Siegmund Nowak 08/93
*
* This routine fills MIM1/MIML in GEDE/GCAL 
***********************************************************************/


#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "gean/ZGESL.h"


extern "C" {
void dggept_() {
  if(ArteTable<GEDE>::booked() && ArteTable<MIMP>::booked() &&
                                  ArteTable<MIMP>::size() > 0) {
    unsigned int iplast = 0;
    for (ArteTableIterator<MIMP> mi; mi.valid(); mi.next() ){ 
      unsigned int ipl = mi->gede.index();
      if(ipl <= 0) continue;
      if(ipl > ArteTable<GEDE>::size()) ipl = ipl&65535;
      ArtePointer<GEDE> gd(ipl);
      if(ipl != iplast) {
         gd->mim1 = mi.index();
         iplast = ipl;
      }
      gd->miml = mi.index();
    }
  }

//   gepc
  if(ArteTable<GCAL>::booked() && ArteTable<MCAL>::booked() &&
                                  ArteTable<MCAL>::size() > 0) {
    unsigned int iplast = 0;
    for (ArteTableIterator<MCAL> mc; mc.valid(); mc.next() ) {
      unsigned int ipl = mc->gcal;
      if(ipl <= 0) continue;
      int isl = ipl >> 24; 
      ipl = ipl&16777215;
      if(isl == 0) {
	if(ipl >= 100) ipl = ipl/100;         
      }
      else {
         ArtePointer<GESL> gs(isl);
         if(gs->cmp == LGESL_ECA) ipl = ipl/100;         
         else if(gs->cmp == LGESL_HOD3) ipl = ipl + gs->fpl -1;
      }
      ArtePointer<GCAL> gc(ipl);
      if(ipl != iplast) {
         gc->mim1 = mc.index();
         iplast = ipl;
      }
      gc->miml = mc.index();
    }
  }
}
}

