
// ******************************************************************
//
// source:    DQ_FARM_raw_evnt.C
//
// type:      source code
//
// created:   23 Oct 2001
//
// author:    Jose Hernandez
//
// called by: DQ_evnt()
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_FARM.h"

// externals
extern float time_rcevnt;

//
// function code
//
int
DQ_FARM_raw_evnt(EVENT_HDR *event)
{
  // show up
  ARTE_mark( "DQ_FARM_raw_evnt 0", 0 );

  //====================================================================
  //       Trigger Code
  //====================================================================
  
  float FCS_tcode = faDDAQFCS_tcode();
  rhp_hf1( DQ_ID( COMP_FARM, LVL_RAW, 1 ), FCS_tcode, 1 );
  
  //====================================================================
  //       Target Rate
  //====================================================================
  
  float ia = faDTARia();
  rhp_hf1( DQ_ID( COMP_FARM, LVL_RAW, 2 ), ia, 1 ); // [MHz]
  
  //====================================================================
  //   get information about slp/farm-nodes
  //====================================================================
  
  int slp_node = faDDAQslp_node();
  rhp_hf1( DQ_ID( COMP_FARM, LVL_RAW, 3 ), slp_node,  1 );

  int farm_node = faDDAQfarm_node();
  rhp_hf1( DQ_ID( COMP_FARM, LVL_RAW, 4 ), farm_node - 50, 1 );
  
  //====================================================================
  //   raw event size
  //====================================================================  
  
  rhp_hf1( DQ_ID( COMP_FARM, LVL_RAW, 6 ), float( faDEVTlength() ) / 1000, 1 ); // [kB]

  //rhp_hf1( DQ_ID( COMP_FARM, LVL_RAW, 101 ), float( ArteTable<DSVD>::size()*sizeof( DSVD ) )/1000, 1 );
  //rhp_hf1( DQ_ID( COMP_FARM, LVL_RAW, 102 ), float( ArteTable<DITR>::size()*sizeof( DITR ) )/1000, 1 );
  //rhp_hf1( DQ_ID( COMP_FARM, LVL_RAW, 104 ), float( ArteTable<DOTR>::size()*sizeof( DOTR ) )/1000, 1 );

  ARTE_mark( "DQ_FARM_raw_evnt 1", 0 );

  return 0;
}
