
// *****************************************************************************
//
// source:    myClassCheck.C
//
// type:      C++ source code
//
// date:      01 Nov 2000
//
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Department of Physics
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// purpose:   Example code to check event whether certain classification bit.
//            Copy code as you needed it.
//
// hints:     see: farm/farm.hh
//            see: reco/eclass.hh
//            see: http://www-hera-b.desy.de/subgroup/farm/ECLASS.html
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ARTE includes
#include "farm/farm.hh"
#include "reco/eclass.hh"

//
// function code
//
void
myClassCheck()
{
  // get classification word (see farm/farm.hh)
  int flagdst = faEVHDflagdst();
  
  // e.g. check bit 11 = SLTEEB (see reco/eclass.hh)
  if( flagdst & ECLASS_SLTEEB ) cout << "Found SLTEBB event!" << endl;
}
