// *****************************************************************************
//
// source:    faMsg.C
//
// created:   01 Oct 2001
//
// Author:    Jose Hernandez
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Jose.Hernandez@desy.de
//
// purpose:   Read and dispatch RPM messages
//
// symbols:   famsg_
//
// called by: arte/mmrevt.F 
// *****************************************************************************

#include <iostream.h>
#include "rpm.h"
#include "rhp.h"
#include "grr.h"
#include "smc.h"
#include "farm/fa.hh"
#include "farm/farm.hh"

extern int  FADEB;  
extern int  RPMINIT;
extern int  FASMC;  

extern "C" int
famsg_()
{
  int rc = GRR_OK;
  ARTE_mark( "faMsg 0", 0 );           

  if(!RPMINIT) return GRR_OK;
  
  // Check and dispatch all rpm messange 
  //
  while( rc == GRR_OK ){
    rc = rhp_wait_for_one_msg_and_dispatch( NO_BLOCK );  //rpm_receive() & rpm_dispatch() inside
  }
 
  // handle rhp (publish histograms) 
  //
  faCheckRhp( FADEB ? 1 : 0 ); // reset histos after publishing to gatherer

  ARTE_mark( "faMsg 1", 1 );    
  return GRR_OK;
}
