// ********************************************************************
//
//  Routine:      gageFillRhpRich.C
//  Author:       T. Oest
//
//  Description: fill rhp histograms for global RICH alignment
//
//  Modification:
//
// ********************************************************************

#include <iostream.h>
#include <math.h>
#include <algo.h>
#include "rhp.h"
#include "dq/DQ.h"
#include "arte/arte.hh"

//*********************************************************************
// function
//*********************************************************************

int gageFillRhpRich(){

//-----------------------------------------------------------------
//   zTarget
//-----------------------------------------------------------------
    float xTARGET = 0.0;
    float yTARGET = 0.0;
    float zTARGET = 0.0;
    float diff;

    int wire=0;

    for( ArteTable<GTAR>::iterator gtar = ArteTable<GTAR>::begin();
         gtar != ArteTable<GTAR>::end();
         ++gtar ) {
      diff = (*gtar)->x * (*gtar)->x + (*gtar)->y * (*gtar)->y;
      if (diff < 1 ) {
       xTARGET = xTARGET + (*gtar)->x;
       yTARGET = yTARGET + (*gtar)->y;
       zTARGET = zTARGET + (*gtar)->z;
       wire++;
      };
    };

    if (wire > 1 ) {
      xTARGET = xTARGET / float(wire);
      yTARGET = yTARGET / float(wire);
      zTARGET = zTARGET / float(wire);
      //cout << " **** " << wire << " wires found " << endl;
    };

//-----------------------------------------------------------------
//   ECAL/RICH correlation
//-----------------------------------------------------------------

    for( ArteTable<RCCL>::iterator rccl = ArteTable<RCCL>::begin();
         rccl != ArteTable<RCCL>::end();
         ++rccl ) {

    for( ArteTable<RSEG>::iterator rRICH = ArteTable<RSEG>::begin();
         rRICH != ArteTable<RSEG>::end();
         ++rRICH ) {

      if ((*rRICH)->cmp == 67108864 &&
          (*rRICH)->ze >= 3.*sqrt(max(float(1.),(*rRICH)->ye))){

         float dtx, dty;
         dtx = ((*rccl)->x - xTARGET)/((*rccl)->z - zTARGET)
                     - (*rRICH)->txf;
         dty = ((*rccl)->y - yTARGET)/((*rccl)->z - zTARGET)
                     - (*rRICH)->tyf;

         if (fabs(dtx)<0.01 && fabs(dty)<0.01)
          rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 110 ), dtx, dty, 1 );

      };
    };
    };
//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
  return 0;
};
