
/***********************************************************************
* CRGWAL
* written by Siegmund Nowak
*
* This routine books and fills the detector bank NWAL for walls
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
*  name        in     name of the wall
*  ncopy       in     geant copy (user) number 
***********************************************************************/

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "gean/gcvolu.h"
#include "gean/Geant2Arte.hh"

extern "C" {

void crgwal_(char name[],int & ncopy) {
  Geant2Arte G2A;

//  get wall geant volume nr ivos 
    int ivos = G2A.GetGvolNumber(name);
    if(ivos == 0) { 
       arteMsg << "crgwal >> nonvalid volume " << name; arteMsg.error();
    } 

//  define the volume tree into lvols,lcopy
    G2A.FillTree(name,ncopy);
    G2A.FillGvolParameter();

//  Book NWAL bank and connect it to NESL bank, fill Nwal 
    int nnwal =G2A.CreateNwal();
    G2A.FillNwalParameter(nnwal);

    gcvolu_.nlevel =0;
}
}

