       subroutine otrmod(cnamfil,ierr)
************************************************************************
*
* Reads definition of OTR module type from a text file
* and fills common otrgeo
*
* Called from: otrgeo
*
* External references: otrcomc,otrcomi,otrcomr, spaces,lnblnk
*
* Arguments  in/out       Description
* =========  ======       ===========
* cnamfil    in           file name to read
* ierr       out          error flag
*
* Author:   Alexander Lanyov     Aug 1999
* Modified: Alexander Lanyov     Nov 2001 (pin distance is different for special modules)
************************************************************************
        implicit none

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/otrgeo.fi"

        real pin_dist
        integer ierr,n,i,j,j1,j2,ic,il,ilay,iy,ibeam,ll,l
        integer nlast,is,ip,ip_old,flt_old,iwiring
        character*40 cnamfil*(*)
        character ch1*1, dir*120, wiring*20, basetype*20

        integer lenocc,icloc,lnblnk,iread

        character*80 spaces
        ! character*(*) spaces !???
        logical otrcomc,otrcomi,otrcomr

#include "arte/Arte.ff"

        if (imod.le.0 .or. imod .gt. notypm) then
           c78 = 'Illegal module number ='
           call ch78bi(imod)
           call meerro (c78)
           ierr=1
           goto 990
        endif


        call zgetfil(dir,ll)
        call otropen(lread1,cnamfil,dir)

        if (cnamfil(:1).eq.' ') then
           c78 = 'File'
           call ch78bc(cnamfil(:lenocc(cnamfil)))
           call ch78bc('was not opened')
           call meerro(c78)
           return
        end if

        cotsid(1,imod)=' '
        cotsid(2,imod)=' '

        do is=1,4
           do il=1,motlay
              notsew(il,is,imod) = 0
              fotsew(il,is,imod) = 0
              notnsw(il,is,imod) = 0
              fotnsw(il,is,imod) = 0
           end do
        end do
        fltmod(imod) = 0
        ignore_g10(imod) = .false.

        pin_dist_mod(imod) = 9.25

c================================================ begin of reading loop
100     continue
        read (lread1,'(a)',end=991) buf

        do i=1,len(buf)
           ic=ichar(buf(i:i))
           if (ic.ge.ichar('A') .and. ic.le.ichar('Z'))
     @        buf(i:i)=char(ic+ichar('a')-ichar('A'))
        end do

c Here we want to throw away string "HB-M5-2001 (2)"
c endpiece (glued)   type top        HB-M5-2001 (2)   1       1       3     3
c
c This operation is not needed for wiring scheme
c (since we need to analyse this string there).

        j = icloc('hb-',lenocc('hb-'),buf,1,lenocc(buf))
        if (j.ne.0 .and. buf(:6).ne.'wiring') then
           j1 = index(buf(j:),' ') + j-1
           c78 = '          extracted "' // buf(j:j1)
           buf(j:j1) = ' '
           if (buf(j1+1:j1+1) .eq.'(') then
              j2 = index(buf(j1:),')') + j1-1
              call ch78ac(buf(j1:j2))
              buf(j1:j2) = ' '
           endif
           call ch78ac('"')
        end if

        buf = spaces(buf,1)
        nlast = lnblnk(buf)
        if (nlast.le.0) goto 100

        if (buf(:1).eq.'*' 
     @       .and. buf(:23).ne.'* baseplate type bottom') goto 100
        cotnam(imod) = cnamfil(:max(1,lenocc(cnamfil)-4))

c=================================================== read module information
        if (otrcomc('module name',cotnam(imod),1)
     @   .or. (otrcomc('module type',cotnam(imod),1)
     2          .and. cotnam(imod)(1:2).eq.'mc')) then
           if (cotnam(imod)(:lenocc(cotnam(imod)))//'.txt'
     @     .ne. cnamfil(:lenocc(cnamfil))) then
              c78 = 'Wrong module name:'
              call ch78bc(cotnam(imod))
              call ch78bc('in file')
              call ch78bc(cnamfil)
              call meerro (c78)
           end if

        else if (otrcomc('module type',cparam,-20)
     @      .or. otrcomc('module stucture',cparam,-20)
     @      .or. otrcomc('module structure',cparam,-20)) then
           if (cparam(1)(:3) .eq. '5mm'
     @    .or. cparam(1)(:2) .eq. '5d'
     @    .or. cparam(1)(:2) .eq. '5s') then
              otdiam(imod) = 0.5
           else if (cparam(1)(:4) .eq. '10mm'
     @    .or. cparam(1)(:3) .eq. '10d'
     @    .or. cparam(1)(:3) .eq. '10s') then
              otdiam(imod) = 1.
           else
              c78 = 'Unknown module type: '//cparam(1)(:lpar(1))
              call meerro (c78)
           endif

        else if (otrcomc('superlayer side',cotsid(1,imod),2)) then

        else if (otrcomr('pin distance, mm',otdist(imod),1)) then
            otdist(imod) = 0.1 * otdist(imod)

        else if (otrcomi('# of modules to produce',notmod(imod),1)) then

        else if (otrcomi('# of modules'           ,notmod(imod),1)) then

        else if (otrcomi('# of layers'     ,notlay(imod),1)
     @      .or. otrcomi('# of wire layers',notlay(imod),1)) then
           notlay(imod) = max(4,notlay(imod))           ! ??
           n = notlay(imod)

        else if (otrcomi('# of channels top',notcht(imod),1)) then

        else if (otrcomi('# of channels bottom',notchb(imod),1)) then

        else if (otrcomr('total foil length, mm',otfoil(imod),1)) then
           otfoil(imod) = 0.1 * otfoil(imod)


c----------------- Sense wire positions - old format
      elseif(otrcomi('# sense wires sector a',notsew(1,1,imod),n)
     @.or.otrcomi('# of sense wires sector a',notsew(1,1,imod),n)) then
              do i=1,n
                 if (notsew(i,1,imod).ne.0) then
                     fotsew(i,1,imod) = 1
                 else
                     fotsew(i,1,imod) = 0
                 end if
              end do


      elseif(otrcomi('# sense wires sector b',notsew(1,2,imod),n)
     @.or.otrcomi('# of sense wires sector b',notsew(1,2,imod),n)) then
              do i=1,n
                 if (notsew(i,2,imod).ne.0) then
                     fotsew(i,2,imod) = 1
                 else
                     fotsew(i,2,imod) = 0
                 end if
              end do


      elseif(otrcomi('# sense wires sector c',notsew(1,3,imod),n)
     @.or.otrcomi('# of sense wires sector c',notsew(1,3,imod),n)) then
              do i=1,n
                 if (notsew(i,3,imod).ne.0) then
                     fotsew(i,3,imod) = 1
                 else
                     fotsew(i,3,imod) = 0
                 end if
              end do


      elseif(otrcomi('# sense wires sector d',notsew(1,4,imod),n)
     @.or.otrcomi('# of sense wires sector d',notsew(1,4,imod),n)) then
              do i=1,n
                 if (notsew(i,4,imod).ne.0) then
                     fotsew(i,4,imod) = 1
                 else
                     fotsew(i,4,imod) = 0
                 end if
              end do


c----------------- Thick wire positions - old format
      elseif(otrcomi('# thick wires sector a',notnsw(1,1,imod),n)
     @.or.otrcomi('# of thick wires sector a',notnsw(1,1,imod),n)) then
              do i=1,n
                 if (notnsw(i,1,imod).ne.0) then
                     fotnsw(i,1,imod) = 1
                 else
                     fotnsw(i,1,imod) = 0
                 end if
              end do

      elseif(otrcomi('# thick wires sector b',notnsw(1,2,imod),n)
     @.or.otrcomi('# of thick wires sector b',notnsw(1,2,imod),n)) then
              do i=1,n
                 if (notnsw(i,2,imod).ne.0) then
                     fotnsw(i,2,imod) = 1
                 else
                     fotnsw(i,2,imod) = 0
                 end if
              end do

      elseif(otrcomi('# thick wires sector c',notnsw(1,3,imod),n)
     @.or.otrcomi('# of thick wires sector c',notnsw(1,3,imod),n)) then
              do i=1,n
                 if (notnsw(i,3,imod).ne.0) then
                     fotnsw(i,3,imod) = 1
                 else
                     fotnsw(i,3,imod) = 0
                 end if
              end do

      elseif(otrcomi('# thick wires sector d',notnsw(1,4,imod),n)
     @.or.otrcomi('# of thick wires sector d',notnsw(1,4,imod),n)) then
              do i=1,n
                 if (notnsw(i,4,imod).ne.0) then
                     fotnsw(i,4,imod) = 1
                 else
                     fotnsw(i,4,imod) = 0
                 end if
              end do

c----------------- Wiring scheme - needed for sense wires position!!!
      else if (otrcomc('wiring scheme',cparam,2)) then  ! HB-M5-2056 (0)
          wiring = cparam(1)                            ! HB-M5-2056
          iwiring = iread(wiring(lenocc(wiring)-3:))    ! 2056

c----------------- Sense wire positions - new format
      else if (otrcomc('cell position of sense wires sector',
     @                                         cparam,-(3*n+1))) then

        ch1 = cparam(1)(:1)
        ip = ichar(ch1) - ichar('a') + 1
        if (ip.le.0 .or. ip.gt.4) then
           c78 = 'Illegal sector' // ch1
           call meerro (c78)
        end if

        do il=1,n
           fotsew(il,ip,imod) = iread(cparam(il*3-1))
           i = iread(cparam(il*3))
           if (i.ne.0) then
              write (*,*) '?? should be zero: cparam(il*3)=',
     @                    cparam(il*3)(:lenocc(cparam(il*3)))
           end if
           notsew(il,ip,imod) = iread(cparam(il*3+1))
        end do

        if (ip.eq.2) then
           if ((otdiam(imod) .eq. 1.0 .and. (iwiring.eq.2063
     @                .or. (iwiring.ge.2053 .and. iwiring.le.2058)))
     @    .or. (otdiam(imod) .eq. 0.5 .and. iwiring.eq.2079)) then

           ignore_g10(imod) = .true.

c           do il=1,n
c              fotsew(il,2,imod) = fotsew(il,1,imod)
c              notsew(il,2,imod) = notsew(il,1,imod)
c           end do

           end if
        end if


c----------------- Thick wire positions - new format
      else if (otrcomc('cell position of thick wires sector',
     @                                         cparam,-(3*n+1))) then

        ch1 = cparam(1)(:1)
        ip = ichar(ch1) - ichar('a') + 1
        if (ip.le.0 .or. ip.gt.4) then
           c78 = 'Illegal sector' // ch1
           call meerro (c78)
        end if

        do il=1,n
           fotnsw(il,ip,imod) = iread(cparam(il*3-1))
           i = iread(cparam(il*3))
           if (i.ne.0) then
              write (*,*) '?? should be zero: cparam(il*3)=',
     @                    cparam(il*3)(:lenocc(cparam(il*3)))
           end if
           notnsw(il,ip,imod) = iread(cparam(il*3+1))
        end do

        if ((ip.eq.4 .and. otdist(imod).eq.0.)
     @ .or.(ip.eq.4 .and. notnsw(il,ip,imod).eq.notsew(il,ip,imod)))then
           ch1 = 'B'
           ip_old = ip
           ip = 2
           do il=1,n
              fotnsw(il,ip,imod) = fotnsw(il,ip_old,imod)
              notnsw(il,ip,imod) = notnsw(il,ip_old,imod)
              fotnsw(il,ip_old,imod) = 0
              notnsw(il,ip_old,imod) = 0
           end do
        end if


c----------------- G10 positions - old format

        else if (otrcomr('g10-strip position up',otg10p(1,1,imod),
     @                                            n)) then
           do ilay=1,n
              otg10p(ilay,1,imod) = 0.1 * otg10p(ilay,1,imod)
           end do

              if (fltmod(imod).eq.1)
     @        call meerro('FLT mode changed for module '// cotnam(imod))
              fltmod(imod) = 2

        else if (otrcomr('g10-strip position mid',otg10p(1,2,imod),
     @                                            n)) then
           do ilay=1,n
              otg10p(ilay,2,imod) = 0.1 * otg10p(ilay,2,imod)
           end do

              if (fltmod(imod).eq.1)
     @        call meerro('FLT mode changed for module '// cotnam(imod))
              fltmod(imod) = 2

        else if (otrcomr('g10-strip position down',otg10p(1,3,imod),
     @                                            n)) then
           do ilay=1,n
              otg10p(ilay,3,imod) = 0.1 * otg10p(ilay,3,imod)
           end do


              if (fltmod(imod).eq.1)
     @        call meerro('FLT mode changed for module '// cotnam(imod))
              fltmod(imod) = 2

c----------------- G10 positions - new format
c to do: read l5r5 (but get information how to interprete it!!)

      elseif(otrcomc('g10-strip pinholder position up',cparam,n)) then


c Ignore up/down G10 strip in modules mc5-2 and mc5-5
           if (otdiam(imod).eq.0.5
     @       .and. (iwiring.eq.2080.or.iwiring.eq.2083)) then
              goto 100
           end if

           do ilay=1,n
              if      (cparam(ilay)(:4).eq.'l2r2'
     @            .or. cparam(ilay)(:4).eq.'l1r4'
     @            .or. cparam(ilay)(:4).eq.'l4r1') then
                 otg10p(ilay,1,imod) = 21.
              else if (cparam(ilay)(:4).eq.'l1r1') then
                 otg10p(ilay,1,imod) = 22.39
              else if (cparam(ilay)(:4).eq.'l5r5'
     @            .or. cparam(ilay)(:4).eq.'l3r6'
     @            .or. cparam(ilay)(:4).eq.'l6r3') then
                 otg10p(ilay,1,imod) = 19.
              else if (cparam(ilay)(:4).eq.'l6r6') then
                 otg10p(ilay,1,imod) = 17.61
              else if (cparam(ilay)(:4).eq.'    '
     @            .or. cparam(ilay)(:4).eq.'-   '
     @            .or. cparam(ilay)(:4).eq.'0   ') then
                 otg10p(ilay,1,imod) = 0.
              else
                 c78 = 'Illegal G10 position description for layer'
                 call ch78bi(ilay)
                 call ch78ac(': "')
                 call ch78ac(cparam(ilay)(:lenocc(cparam(ilay))))
                 call ch78ac('"')
                 call meerro(c78)
              end if
           end do

           do ilay=1,n
              if (cparam(ilay)(1:1).eq.'l'
     @      .and. cparam(ilay)(3:3).eq.'r') then
                 flt_old = fltmod(imod)
                 if (cparam(ilay)(2:2).ne.cparam(ilay)(4:4)) then
                    fltmod(imod) = 1
                 else
                    fltmod(imod) = 2
                 end if
                 if (fltmod(imod).ne.flt_old .and. flt_old.ne.0) then
                    call meerro('FLT mode changed for module '
     @                          // cotnam(imod))
                 end if
              end if
           end do



      elseif(otrcomc('g10-strip pinholder position mid',cparam,n)) then
           do ilay=1,n
              if      (cparam(ilay)(:4).eq.'l2r2'
     @            .or. cparam(ilay)(:4).eq.'l1r4'
     @            .or. cparam(ilay)(:4).eq.'l4r1') then
                 otg10p(ilay,2,imod) = 1.
              else if (cparam(ilay)(:4).eq.'l1r1') then
                 otg10p(ilay,2,imod) = 2.39
              else if (cparam(ilay)(:4).eq.'l5r5'
     @            .or. cparam(ilay)(:4).eq.'l3r6'
     @            .or. cparam(ilay)(:4).eq.'l6r3') then
                 otg10p(ilay,2,imod) = -1.
              else if (cparam(ilay)(:4).eq.'l6r6') then
                 otg10p(ilay,2,imod) = -2.39
              else if (cparam(ilay)(:4).eq.'    '
     @            .or. cparam(ilay)(:4).eq.'-   '
     @            .or. cparam(ilay)(:4).eq.'0   ') then
                 otg10p(ilay,2,imod) = 0.
              else
                 c78 = 'Illegal G10 position description for layer'
                 call ch78bi(ilay)
                 call ch78ac(': "')
                 call ch78ac(cparam(ilay)(:lenocc(cparam(ilay))))
                 call ch78ac('"')
                 call meerro(c78)
              end if
           end do

           do ilay=1,n
              if (cparam(ilay)(1:1).eq.'l'
     @      .and. cparam(ilay)(3:3).eq.'r') then
                 flt_old = fltmod(imod)
                 if (cparam(ilay)(2:2).ne.cparam(ilay)(4:4)) then
                    fltmod(imod) = 1
                 else
                    fltmod(imod) = 2
                 end if
                 if (fltmod(imod).ne.flt_old .and. flt_old.ne.0) then
                    call meerro('FLT mode changed for module '
     @                          // cotnam(imod))
                 end if
              end if
           end do



      elseif(otrcomc('g10-strip pinholder position down',cparam,n))then

c Ignore up/down G10 strip in modules mc5-2 and mc5-5
           if (otdiam(imod).eq.0.5
     @       .and. (iwiring.eq.2080.or.iwiring.eq.2083)) then
              goto 100
           end if

           do ilay=1,n
              if      (cparam(ilay)(:4).eq.'l2r2'
     @            .or. cparam(ilay)(:4).eq.'l1r4'
     @            .or. cparam(ilay)(:4).eq.'l4r1') then
                 otg10p(ilay,3,imod) = -19.
              else if (cparam(ilay)(:4).eq.'l1r1') then
                 otg10p(ilay,3,imod) = -17.61
              else if (cparam(ilay)(:4).eq.'l5r5'
     @            .or. cparam(ilay)(:4).eq.'l3r6'
     @            .or. cparam(ilay)(:4).eq.'l6r3') then
                 otg10p(ilay,3,imod) = -21.
              else if (cparam(ilay)(:4).eq.'l6r6') then
                 otg10p(ilay,3,imod) = -22.39
              else if (cparam(ilay)(:4).eq.'    '
     @            .or. cparam(ilay)(:4).eq.'-   '
     @            .or. cparam(ilay)(:4).eq.'0   ') then
                 otg10p(ilay,3,imod) = 0.
              else
                 c78 = 'Illegal G10 position description for layer'
                 call ch78bi(ilay)
                 call ch78ac(': "')
                 call ch78ac(cparam(ilay)(:lenocc(cparam(ilay))))
                 call ch78ac('"')
                 call meerro(c78)
              end if
           end do

           do ilay=1,n
              if (cparam(ilay)(1:1).eq.'l'
     @      .and. cparam(ilay)(3:3).eq.'r') then
                 flt_old = fltmod(imod)
                 if (cparam(ilay)(2:2).ne.cparam(ilay)(4:4)) then
                    fltmod(imod) = 1
                 else
                    fltmod(imod) = 2
                 end if
                 if (fltmod(imod).ne.flt_old .and. flt_old.ne.0) then
                    call meerro('FLT mode changed for module '
     @                          // cotnam(imod))
                 end if
              end if
           end do



c----------------- E-beam positions
      elseif(otrcomc('g10-strip pinholder e-beam position',
     @                                                cparam,n+1)) then
           if (cparam(1)(:2) .eq. 'i ') then
              ibeam = 1
           else if (cparam(1)(:2) .eq. 'ii') then
              ibeam = 2
           else
              call meerro('Wrong e-beam position descriptor')
           end if

           do ilay=1,n
              if      (cparam(ilay+1)(:4).eq.'l2r2') then
                 if (ibeam.eq.1) then
                    otbeam(ilay,ibeam,imod) = -68.              ! approximate!
                 else
                    otbeam(ilay,ibeam,imod) = -96.
                 end if
              else if (cparam(ilay+1)(:4).eq.'l5r5') then
                 if (ibeam.eq.1) then
                    otbeam(ilay,ibeam,imod) = -66.
                 else
                    otbeam(ilay,ibeam,imod) = -94.
                 end if
              else if (cparam(ilay+1)(:4).eq.'    ') then
                 otbeam(ilay,ibeam,imod) = 0.
              else
                 c78 = 'Illegal e-beam position description:'
                 call ch78bc(cparam(i)(:lenocc(cparam(ilay+1))))
                 call meerro(c78)
              end if
           end do


c------------------------------ distances to first/last cell/wire - old format
      else if (otrcomr('dist. hole to first cell center',
     @                                      otcefi(1,1,imod),n)) then

           do ilay=1,n
           do iy=2,1,-1
              otcefi(ilay,iy,imod) = 0.1 * otcefi(ilay,1,imod)
           end do
           end do

      elseif(otrcomr('dist. hole to last cell center',
     @                                    otcela(1,1,imod),n)) then

           do ilay=1,n
           do iy=2,1,-1
              otcela(ilay,iy,imod) = 0.1 * otcela(ilay,1,imod)
           end do
           end do



        else if (otrcomr('dist. hole to first wire',otwifi(1,1,imod),
     @                                            n)) then
           do ilay=1,n
           do iy=2,1,-1
              otwifi(ilay,iy,imod) = 0.1 * otwifi(ilay,1,imod)
           end do
           end do

        else if (otrcomr('dist. hole to last wire',otwila(1,1,imod),
     @                                            n)) then
           do ilay=1,n
           do iy=2,1,-1
              otwila(ilay,iy,imod) = 0.1 * otwila(ilay,1,imod)
           end do
           end do

c------------------------------ distances to first/last cell/wire - new format
c to do: split arrays to two species (or additional index?)

      else if (otrcomr('distance hole (baseplate) to first cell (y>0)',
     @                                         otcefi(1,1,imod),n)
     @ .or. otrcomr('x-distance hole (baseplate) to first cell (y>0)',
     @                                         otcefi(1,1,imod),n)) then

           do ilay=1,n
              otcefi(ilay,1,imod) = 0.1 * otcefi(ilay,1,imod)
           end do

      else if (otrcomr('distance hole (baseplate) to first cell (y<0)',
     @                                         otcefi(1,2,imod),n)
     @ .or.otrcomr('x-distance hole (baseplate) to first cell (y<0)',
     @                                         otcefi(1,2,imod),n)) then

           do ilay=1,n
              otcefi(ilay,2,imod) = 0.1 * otcefi(ilay,2,imod)
           end do

      else if (otrcomr('distance hole (baseplate) to last cell (y>0)',
     @                                         otcela(1,1,imod),n)
     @ .or. otrcomr('x-distance hole (baseplate) to last cell (y>0)',
     @                                         otcela(1,1,imod),n)) then

           do ilay=1,n
              otcela(ilay,1,imod) = 0.1 * otcela(ilay,1,imod)
           end do


      else if (otrcomr('distance hole (baseplate) to last cell (y<0)',
     @                                         otcela(1,2,imod),n)
     @ .or. otrcomr('x-distance hole (baseplate) to last cell (y<0)',
     @                                         otcela(1,2,imod),n)) then

           do ilay=1,n
              otcela(ilay,2,imod) = 0.1 * otcela(ilay,2,imod)
           end do



      else if (otrcomr('distance hole (baseplate) to first wire (y>0)',
     @                                         otwifi(1,1,imod),n)
     @ .or. otrcomr('x-distance hole (baseplate) to first wire (y>0)',
     @                                         otwifi(1,1,imod),n)) then
           do ilay=1,n
              otwifi(ilay,1,imod) = 0.1 * otwifi(ilay,1,imod)
           end do


      else if (otrcomr('distance hole (baseplate) to first wire (y<0)',
     @                                         otwifi(1,2,imod),n)
     @ .or. otrcomr('x-distance hole (baseplate) to first wire (y<0)',
     @                                         otwifi(1,2,imod),n)) then
           do ilay=1,n
              otwifi(ilay,2,imod) = 0.1 * otwifi(ilay,2,imod)
           end do


      else if (otrcomr('distance hole (baseplate) to last wire (y>0)',
     @                                         otwila(1,1,imod),n)
     @ .or. otrcomr('x-distance hole (baseplate) to last wire (y>0)',
     @                                         otwila(1,1,imod),n)) then
           do ilay=1,n
              otwila(ilay,1,imod) = 0.1 * otwila(ilay,1,imod)
           end do

      else if (otrcomr('distance hole (baseplate) to last wire (y<0)',
     @                                         otwila(1,2,imod),n)
     @ .or. otrcomr('x-distance hole (baseplate) to last wire (y<0)',
     @                                         otwila(1,2,imod),n)) then
           do ilay=1,n
              otwila(ilay,2,imod) = 0.1 * otwila(ilay,2,imod)
           end do

c------------------------------ Supporting G10 positions

        else if (otrcomr('support pos. up a',otsupp(1,1,imod),
     @                                            n)) then
           do il=1,n
              otsupp(il,1,imod) = 0.1 * otsupp(il,1,imod)
           end do

        else if (otrcomr('support pos. up b',otsupp(1,2,imod),
     @                                            n)) then
           do il=1,n
              otsupp(il,2,imod) = 0.1 * otsupp(il,2,imod)
           end do

        else if (otrcomr('support pos. up c',otsupp(1,3,imod),
     @                                            n)) then
           do il=1,n
              otsupp(il,3,imod) = 0.1 * otsupp(il,3,imod)
           end do

        else if (otrcomr('support pos. down a',otsupp(1,4,imod),
     @                                            n)) then
           do il=1,n
              otsupp(il,4,imod) = 0.1 * otsupp(il,4,imod)
           end do

        else if (otrcomr('support pos. down b',otsupp(1,5,imod),
     @                                            n)) then
           do il=1,n
              otsupp(il,5,imod) = 0.1 * otsupp(il,5,imod)
           end do

        else if (otrcomr('support pos. down c',otsupp(1,6,imod),
     @                                            n)) then
           do il=1,n
              otsupp(il,6,imod) = 0.1 * otsupp(il,6,imod)
           end do

        else if (otrcomc('* baseplate type bottom',basetype,1)) then
           l = lenocc(basetype)

           pin_dist = 9.25

           if (l.ge.3) then
              if      (basetype(l-2:).eq.'sp1') then ! E-beam, MC03, MC04, MC05, MC06, MC08
                 pin_dist = 5.05
              else if (basetype(l-2:).eq.'sp5') then ! MC05, MC06
                 pin_dist = 7.55
              else if (basetype(l-2:).eq.'sp4') then ! MC06
                 pin_dist = 7.55
              else if (basetype(l-2:).eq.'sp3') then ! MC08
                 pin_dist = 9.25
              endif
           endif

c           write (*,*) 'otrmod: ',cotnam(imod),
c     @          ' basetype = ',basetype,', pin_dist =',pin_dist

           pin_dist_mod(imod) = pin_dist ! it was set also as default value 

      else if (otrcomc('module label'     , cparam, -10)) then
         goto 991  ! End of file

c----------------- Command was not found above.
        else
           write (*,*) '??? Unknown command: ',buf(:nlast)
cccc temporary             stop
        end if
        goto 100

c================================================ end of reading loop
991     continue
        call ioclos(lread1)
        ierr=0

990     continue
        n=0
        do il=1,notlay(imod)
           do i=1,2
              if (otcefi(il,i,imod).ne.0.) n=il
              if (otcela(il,i,imod).ne.0.) n=il
              if (otwifi(il,i,imod).ne.0.) n=il
              if (otwila(il,i,imod).ne.0.) n=il
              if (otbeam(il,i,imod).ne.0.) n=il
           end do
           do i=1,3
              if (otg10p(il,i,imod).ne.0.) n=il
           end do
           do i=1,6
              if (otsupp(il,i,imod).ne.0.) n=il
           end do
           do i=1,4
              if (notsew(il,i,imod).ne.0) n=il
              if (fotsew(il,i,imod).ne.0) n=il
              if (notnsw(il,i,imod).ne.0) n=il
              if (fotnsw(il,i,imod).ne.0) n=il
           end do
        end do
        notlay(imod)=n

        return
        end
