*CMZ :  1.00/07 30/10/95  12.23.45  by  Fedor Ratnikov
*CMZ :  1.00/00 03/01/95  15.54.59  by  Dominik Ressing
*CMZ :  0.01/02 12/08/94  18.09.29  by  Dominik Ressing
*-- Author :    Dominik Ressing   11/08/94
************************************************************************
*
* T1ECATH
* written by Dominik Ressing, 11/08/94 20.23.11
*
* This routines action:
* returns cut value for cluster. If T1ECATH > 1 the candidate is accepted
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* E0         in           energy of central block
* N          in           number of surrounding blocks
* Ei         in           energy of surrounding blocks
* x0         in           x of center of central block
* y0         in           y of center of central block
*
************************************************************************
c
      REAL FUNCTION T1ECATH(E0,N,Ei,x0,y0)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
c
      REAL    E0,Ei(*),x0,y0,ES,T1ECACU
      INTEGER N,i
      EXTERNAL T1ECACU
c
      T1ECATH = 0.
c
      ES = E0
      DO i=1,N
       IF ( Ei(i).ge.E0 ) RETURN ! E0 should be larger then all others
       IF(Ei(i).GE.0.)   THEN ! only positive energy accepted
        ES = ES + Ei(i)
       ENDIF
      END DO
      T1ECATH = ES/T1ECACU(x0,y0) ! thershold value >1 = acceppted
c
      RETURN
c
      END
