
*  B.Fominykh  14.04.2000
*  the program of MuonID package
*  calculation of contributions to muon likelihood 
*  input:  IBR     - branch number
*  output: RHOL    - ratio of holes
*          MDW(8)  - map of double wires (8=3+3+1+1)
*          MPD(2)  - map of pads in MU3, MU4
*
      SUBROUTINE MURLHC(IBR,RHOL,MDW,MPD)
C-    ===================================
      IMPLICIT NONE
      INTEGER IBR,MDW(8),MPD(2)
      INTEGER JBR,JBRHM,I,J,K,IH,JH,IHT,JHT,MUSL,LAY
      INTEGER NHOLI,NHOLO,NHITI,NHITO,NHOL,NHIT,NW(4,3)
      REAL RHOL,ZW(4,3,3)
#include "murec/MUCBTAB.fi"
#include "arte/Arte.fi"
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      RHOL=-1.
      DO I=1,2
        MPD(I)=0
      ENDDO
      DO I=1,8
        MDW(I)=0
      ENDDO
      IF(IBR.LE.0) GOTO 200

      JBR=JTMP7+IQ(JTMP7+1)*(IBR-1)+2
* control of number of collected hits
      IF(IQ(JBR+8).LT.3) GOTO 200
* calculate the number of holes in the hit-map
      JBRHM=JBR+8
      NHOLI=0
      NHOLO=0
      NHITI=0
      NHITO=0
* MU1
      IF(IQ(JBRHM+4).GT.0) NHITI=NHITI+1
      IF(IQ(JBRHM+4).LE.0) NHOLI=NHOLI+1
      DO I=1,3
        IF(IQ(JBRHM+I).GT.0) NHITO=NHITO+1
        IF(IQ(JBRHM+I).LE.0) NHOLO=NHOLO+1
      ENDDO
* MU2
      IF(IQ(JBRHM+8).GT.0) NHITI=NHITI+1
      IF(IQ(JBRHM+8).LE.0) NHOLI=NHOLI+1
      DO I=5,7
        IF(IQ(JBRHM+I).GT.0) NHITO=NHITO+1
        IF(IQ(JBRHM+I).LE.0) NHOLO=NHOLO+1
      ENDDO
* MU3
      IF(IQ(JBRHM+10).GT.0) NHITI=NHITI+1
      IF(IQ(JBRHM+10).LE.0) NHOLI=NHOLI+1
      IF(IQ(JBRHM+9).GT.0)  NHITO=NHITO+1
      IF(IQ(JBRHM+9).LE.0)  NHOLO=NHOLO+1
* MU4
      IF(IQ(JBRHM+12).GT.0) NHITI=NHITI+1
      IF(IQ(JBRHM+12).LE.0) NHOLI=NHOLI+1
      IF(IQ(JBRHM+11).GT.0) NHITO=NHITO+1
      IF(IQ(JBRHM+11).LE.0) NHOLO=NHOLO+1
* calculate the ratio of holes
      NHOL= 0
      NHIT= 0
      IF(NHITI.LT.3.AND.NHITO.LT.3) GOTO 200
      IF(NHITI.GE.3) THEN
        NHIT=NHITI
        NHOL=NHOLI
      ELSE
        IF(NHITO.GT.3) THEN
          NHIT=NHITO
          NHOL=NHOLO
        ELSE
          GOTO 200
        ENDIF
      ENDIF
      RHOL=REAL(NHOL)/REAL(NHIT)

      DO I=1,4
        DO J=1,3
          NW(I,J)=0
          DO K=1,3
            ZW(I,J,K)=0.
          ENDDO
        ENDDO
      ENDDO
* loops over collected hits
      DO 20 IH=1,IQ(JBR+8)
        JH=JBR+LCMUTR+IH
        IHT=IQ(JH)
        JHT=JTMP8+IQ(JTMP8+1)*(IHT-1)+2
        MUSL=IQ(JHT+3)
        LAY =IQ(JHT+4)
* wires
        IF(IQ(JHT+5).EQ.1) THEN
          NW(MUSL,LAY)=NW(MUSL,LAY)+1
          I=NW(MUSL,LAY)
          ZW(MUSL,LAY,I)=Q(JHT+6)
        ENDIF
* pads
        IF(IQ(JHT+5).EQ.2.AND.MUSL.GT.2) MPD(MUSL-2)=MPD(MUSL-2)+1
  20  CONTINUE

* make the map of double wires MDW(8), 8=3+3+1+1
* MU1, MU2
      DO I=1,2
        DO J=1,3
          K=3*(I-1)+J
          MDW(K)=0
          IF(NW(I,J).GT.0) MDW(K)=1
          IF(NW(I,J).EQ.2) THEN
            IF(ABS(ZW(I,J,1)-ZW(I,J,2)).GT.1.) MDW(K)=2
          ENDIF
        ENDDO
      ENDDO
* MU3, MU4
      DO I=3,4
        K=4+I
        MDW(K)=0
        IF(NW(I,1).GT.0) MDW(K)=1
        IF(NW(I,1).EQ.2) THEN
          IF(ABS(ZW(I,1,1)-ZW(I,1,2)).GT.1.) MDW(K)=2
        ENDIF
      ENDDO
*
 200  CONTINUE
      RETURN
      END




