*CMZ :  2.00/00 03/01/94  19.59.32  by  Rainer Mankel
*-- Author :    Rainer Mankel   10/11/93

      subroutine diaxop(xmi0,xma0,x0,x1,wxmin,wxmax,ndivx)

*     **** optimize divisions for axis
      implicit none

      real xmin, xmax, x0, x1, wxmin, wxmax, xmi0, xma0, dxi, dxilg
      real dxif, dxf, dx, frmarg
      integer ndivx, nx, nbini

      parameter (nbini=10,frmarg=0.08)

*     **** margin
      xmin = xmi0 + frmarg * (xma0 - xmi0)
      xmax = xma0 - frmarg * (xma0 - xmi0)

*     **** ideal binning
      dxi = abs(xmax - xmin) / nbini

*     **** log rounding
      dxilg = alog10( dxi )
      dxif  = amod(dxilg,1.)
      if (dxif.lt.0.) dxif = dxif + 1.
      if (dxif.lt.0.15) then
       dxf = 0.
      elseif (dxif.lt.0.5) then
       dxf = alog10(2.)
      elseif (dxif.lt.0.85) then
       dxf = alog10(5.)
      else
       dxf = 1.
      endif

      dx = 10.**(dxilg - dxif + dxf)

*     **** round xmin
      if (xmin.gt.0.) then
       x0 = xmin - amod(xmin,dx) + dx
      else
       x0 = xmin - amod(xmin,dx)
      endif
      if (xmax.gt.0.) then
       x1 = xmax - amod(xmax,dx)
      else
       x1 = xmax - amod(xmax,dx) - dx
      endif

      nx = (x1 - x0) / dx + 0.001

      ndivx = nx

*     **** bypass lg-opt
      x0 = xmin
      x1 = xmax
      ndivx = nbini

*     **** set wxmin, wxmax in any case
      wxmin = x0
      wxmax = x1

      end

