// 
//  Author:  Rainer Mankel                     Created:  01-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/SNM.hh"

rangerSNM::rangerSNM(const int cmp1,const int sec1,
                     const int cmp2,const int sec2,
		     const int cmp3,const int sec3,
		     const int cmp4,const int sec4,
		     const int cmp5,const int sec5,
		     const int cmp6,const int sec6,
		     const int cmp7,const int sec7,
		     const int cmp8,const int sec8,
		     const int cmp9,const int sec9,
		     const int cmp10,const int sec10,
		     const int cmp11,const int sec11,
		     const int cmp12,const int sec12){
  own = make_pair(cmp1,sec1);

  neighbs.push_back( pair<int,int> (cmp1,sec1) );
  if (cmp2 && sec2) neighbs.push_back( pair<int,int> (cmp2,sec2) );
  if (cmp3 && sec3) neighbs.push_back( pair<int,int> (cmp3,sec3) );
  if (cmp4 && sec4) neighbs.push_back( pair<int,int> (cmp4,sec4) );
  if (cmp5 && sec5) neighbs.push_back( pair<int,int> (cmp5,sec5) );
  if (cmp6 && sec6) neighbs.push_back( pair<int,int> (cmp6,sec6) );
  if (cmp7 && sec7) neighbs.push_back( pair<int,int> (cmp7,sec7) );
  if (cmp8 && sec8) neighbs.push_back( pair<int,int> (cmp8,sec8) );
  if (cmp9 && sec9) neighbs.push_back( pair<int,int> (cmp9,sec9) );
  if (cmp10 && sec10) neighbs.push_back( pair<int,int> (cmp10,sec10) );
  if (cmp11 && sec11) neighbs.push_back( pair<int,int> (cmp11,sec11) );
  if (cmp12 && sec12) neighbs.push_back( pair<int,int> (cmp12,sec12) );

//   cout << "own pair: " << own.first << " " << own.second << endl;

}


void rangerSNM::dump(const int level) {
  cout << "  SNM=" << own.first << "/" << own.second << endl;
  if (level >=2) {
    cout << "   neighbs --> ";
    for (vector<pair<int,int> >::const_iterator ngi=neighbs.begin();
	 ngi != neighbs.end(); ++ngi) {
      cout << " " << (*ngi).first << "/" << (*ngi).second << " ";
    }
    cout << endl;
  }
}


void rangerSNM::test(const int level) {
  //  cout << "  SNM=" << own.first << "/" << own.second << endl;
  if (level >=2) {
    cout << "     +  ";
    for (vector<pair<int,int> >::const_iterator ngi=neighbs.begin();
	 ngi != neighbs.end(); ++ngi) {
      switch ((*ngi).first) {
      case 1:
	cout << (*ngi).second + 20 << ",";
	break;
      case 2:
	cout << (*ngi).second << ",";
	break;
      case 3:
	cout << (*ngi).second + 12 << ",";
	break;
      default:
	cout << "??,";
      }
    }
    cout << endl;
  }
}
