// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
// Modified:   
// - moved many routines to State.C
// - introduced accessors to covmatrix elements
//                                     14-Aug-00 Wouter Hulsbergen

// class rangerStateL
// state class for linear tracking

#ifndef rangerStateL_HH
#define rangerStateL_HH

#ifndef rangerState_HH
#include "rang/State.hh"
#endif
#ifndef rangerHitBase_HH
#include "rang/HitBase.hh"
#endif

class rangerStateL : public rangerState {

public:
  rangerStateL() : rangerState(4) {} 
  //rangerStateL(const rangerStateL& s) : rangerState(s) {} ;  // copy constructor
  virtual ~rangerStateL() {}
  //   virtual rangerStateL& operator=(const rangerState& s) { 
  //     if(fitMode()==s.fitMode()) assign(s) ;rangerState::operator=(s) ; return *this ; }
  //   rangerStateL& operator=(const rangerStateL& s) { 
  //     rangerState::operator=(s) ; return *this ; }
  
  virtual rangerFitMode fitMode() const { return ModeL; }
  virtual rangerState* clone() const { return new rangerStateL(*this); } // produce copy

  virtual int predict(const double& zDestination,
	      const double& qPExp,rangerState*& targetState,
		      HepMatrix*& FTransport) const;  // perform Kalman filter prediction
  virtual void project(HepVector& resid,HepMatrix& HH,rangerHitBase* hit) {
    hit->projectL(resid,HH,this); } ;

public:
  
  virtual const double qP() const { return 0 ;}
  virtual const double I()  const { return 0 ;}

  virtual void setQp(double qp) {}
  virtual void setI(double i)   {}

protected:

  virtual const double covXQp()  const { return 0; }
  virtual const double covXI()   const { return 0; }
  virtual const double covYQp()  const { return 0; }
  virtual const double covYI()   const { return 0; }
  virtual const double covTxQp() const { return 0; }
  virtual const double covTxI()  const { return 0; }
  virtual const double covTyQp() const { return 0; }
  virtual const double covTyI()  const { return 0; }
  virtual const double covQpQp() const { return 0; }
  virtual const double covQpI()  const { return 0; }
  virtual const double covII()   const { return 0; }

  virtual void setCovXQp(const double v) {}
  virtual void setCovXI(const double v)  {}
  virtual void setCovYQp(const double v) {}
  virtual void setCovYI(const double v)  {}
  virtual void setCovTxQp(const double v){}
  virtual void setCovTxI(const double v) {}
  virtual void setCovTyQp(const double v){}
  virtual void setCovTyI(const double v) {}
  virtual void setCovQpQp(const double v){}
  virtual void setCovQpI(const double v) {}
  virtual void setCovII(const double v)  {}
  
} ;

#endif
