// 
//  Author:  Rainer Mankel                     Created:  22-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rgsetdseg_
// Fortran interfaced shortcut to rangerDomain::domSeg()->setDomSeg(...).
// Sets the track position and direction of the horizontal track candidate
// in a given domain, which can be used to convert stereo coordinates of 
// this domain to y coordinates for vertical tracking.

#include <iostream.h>
#include "rang/Domain.hh"
#include "rang/DomSeg.hh"

extern "C" {
  void rgsetdseg_(rangerDomain*& dm,
		  const double& z,const double& x,const double& tx,
		  rangerDomWin*& dw) {
    
    if (! dm->domSeg()) {
      cout << "rgsetdseg: not a valid domain" << endl;
      return;
    }

    dm->domSeg()->setDomSeg(z,x,tx,dw);
  }
}

