*-- Author :    A. Spiridonov   01/06/99
*   changed :
*   new parameter seed                              27/08/00  A. Spiridonov
*   magnet tracking of PC segments                  01/11/00  A. Spiridonov

*#define EXT_DEBUG

      subroutine tfextre(seed)
*
*     track reconstruction in OT & IT by means
*     of propagation of external seeds 
*
*      seed=1 , seed planted in PC1, downstream propagation
*          =2 ,                 PC4, upstream
*          =3 ,                 TC1, downstream
*          =4 ,                 TC2, upstream 
*

      implicit none

#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#include "rang/zf.fi"
#include "rang/zdomain.fi"
#include "rang/ztripl.fi"
#include "rang/zcut.fi"
#include "pris/zpstat.fi"
#include "arte/ArteFlag.fi"
#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/RSEG.fi"
#include "arte/RSEG_cmp.fi"
#include "rang/descend.fi"
#include "rang/FIXtrit.hh"
#include "rang/zfextse.fi"
#include "rang/zfpar_ext.fi"
#include "rang/zfparext.fi"

      integer seed,ift,iiseg,ift1,ift2,nca_x,direction,
     +      begin_store,istat,nca_prep

      logical init

      save init
      data init /.false./

      integer muon1,muon2
      integer nh,nh_PC,imimp,jaux,imc,nhmimp,imcass,NRSEG_rec
      integer iseed,seg_seed
      real fracmc
      real dtx,dty,dtxi,dtyi

      equivalence ( pstat_gold(1,1),muon1 )
      equivalence ( pstat_gold(2,1),muon2 )

      integer nca_PC,if_prep,ift_best,nca_store
      real quality_max

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/RSEG.ff"

******************************************************************
*
*     Organization of storage:
*
*           1                  |
*           .                  | x candidates
*           .                  |
*         nca_x                |
*           .                   |
*           .                   | y candidates, 3d candidates
*         nca_y                 |
*           .                    |
*           .                    | magnet seeds
*         nca_prep               |
*           .                     |
*           .                     | magnet candidates
*           .                     |
*
******************************************************************

**      print '("tfextre.F : ===== start seed ",i5)',seed
**      slt_magn_zfpar = .true.

      l_diag = .false.
      diag_level = 0

      call rginit()
      if (.not.l_rinit) call tfrinit() ! restricted init

**      call rghlevnt()                                      ! domain hits

      l_term = .false.
      lremzc = .false.

*     **** do the work

      if(N_ext_seed.le.0) go to 999

      do 10 iiseg=1,N_ext_seed     ! loop over external seeds
        
         call tfclr()           ! clear p.r. buffer
         begin_ft = 1

*         print '("tfextre : TAKE EXTERNAL seed",i4 )',iiseg

         call tfextse(seed,iiseg,ift1,ift2,istat)    ! seed

*         print '("tfextre : ext seed",i4," istat=",i2)',iiseg,istat

*          if(istat.lt.0) then
*            print *,'tfextre: ==== tfextse seed,ift1,ift2,istat=',
*     +              iiseg,ift1,ift2,istat
*          end if

         direction = -1

         nca_prep = ift2        ! store new endpointer

         l_2dx = .false.
         l_2dy = .false.
         l_mag = .true.
         begin_ft = nca_prep + 1
         istat = 0

         if(seed.eq.2.or.seed.eq.4) call tfextpro(seed,ift1,-1,istat) ! upstream
         if(seed.eq.1.or.seed.eq.3) call tfextpro(seed,ift1,1,istat) ! downstream

*         print *,' tfextre: tftcpro returns istat=',istat

         if (istat.ge.0) then
         elseif (istat.le.-100) then
            go to 999           ! no further propagation
         elseif (istat.le.-1) then
            go to 10            ! terminate branch
         endif

         if (diag_level.ge.2) then
            call tfl()
            print *,' after tfextpro,before tfbest'
            call tfwait()
         endif
         begin_ft = nca_prep + 1
         call tfbest()
         if (diag_level.ge.3) then
            call tfl()
            print *,' after tfbest'
            call tfwait()
         endif

*        **** store loop
 9       continue

         begin_store = nca_prep + 1
         nca_PC = nca_ft 
         if_prep = 0
         nca_store = begin_store

         do 40 ift=begin_store,nca_PC
            if (.not.alive_ft(ift)) go to 40               
            if (quality_ft(ift).lt.quality_ext_min) go to 40
               
#ifdef EXT_DEBUG
               print '(" tfextre.F : ift, qmin, q ",i4,2f8.3)'
     +              ,ift,quality_ext_min,quality_ft(ift)
#endif
                            
               call tfsmfin(ift) !    segment fit
**               print '("tfextre.F : want to store ift,qual ",i5,f8.3)'
**     +                ,ift,quality_ft(ift)
               
**               call tfstseg(ift)

               if(slt_magn_zfpar) then !  with magnet tracking
                  
                  call tfmprep(ift,istat)  

                  if(istat.eq.0) if_prep = 1

**                  print '("tfextre.F: mprep ift,nca_PC,nca_ft "
**     +                 ,3i5)',ift,nca_PC,nca_ft

               endif

 40      continue

         if(slt_magn_zfpar.and.if_prep.ne.0) then     ! magnet tracking
            
            nca_prep = nca_ft   ! store new endpointer
            
            l_2dx = .false.
            l_2dy = .false.
            l_mag = .true.
            begin_ft = nca_prep + 1
            istat = 0
            
            call tfpropms(nca_PC+1,-1,istat)
            
*     *            print '("tfextre.F : tfbest begin_ft,nca_ft ",2i5 )'
*     *     +             ,begin_ft,nca_ft
*     *            call tfbest()
            
         end if

*           **** store loop
            begin_store = nca_prep + 1
            quality_max = 0.
            ift_best = 0

**            print '("tfextre.F : store begin_store,nca_ft ",2i5 )'
**     +           ,begin_store,nca_ft

            do ift=nca_store,nca_ft
               if (alive_ft(ift)) then 
                  if (quality_ft(ift).gt.quality_max) then 
                     quality_max = quality_ft(ift)
                     ift_best = ift
                  end if
               end if
            end do

**            print '("tfextre.F : ift_best,quality_max ",i5,f8.3)'
**     +             ,ift_best,quality_max

            if(ift_best.gt.0) call tfstseg(ift_best)

 10   continue                  !  end of loop on seeds

 999  return
      end
