*-- Author :    Rainer Mankel   13/01/97
*-- changed:    A.Spiridonov    22/04/98
*-- changed:    Rainer Mankel   03/10/98

      subroutine tfrfseg(iseg,elec0_corr,istat)

*     **** track fit using hits from a segment
      implicit none
#include "arte/Arte.fi" 
#include "pris/zmh.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zplx.fi" 

      integer iseg              ! rseg to be fitted
      integer elec_corr,        ! electron bremsstrahlung corr flag
     +        istat             ! <0 if error

      integer nzfmx_s,elec0_corr
      parameter (nzfmx_s=300)
      integer ind_s(nzfmx_s),hit_s(nzfmx_s),rhit_s(nzfmx_s),nzf_s,
     +     ift, izf,
     +  jpl, xsig, ii, jj, kk, jzf, ih, iso, rh,ind_rhit,
     +  mimp_s(nzfmx_s), mimp, iih, nhits, 
     +  gcode, cmp, ll, ifail, iter
      integer message_id_1,message_id_2,message_id_3
      double precision dz, du, cs_thetu, xm_p, xr_p,
     +        cr_p, hch, kalman(dimp,dimm), ihk, m_u, sum
      double precision f(5,5,nzfmx_s) ! store transport matrix
      double precision dppi(5,5), ak(5,5)

      real z_s(nzfmx_s),xwire,qold,delta_q,f_corr,
     +     q_init,qp_init
      logical lsmoo
      logical init

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
#include "auto/RTRA.fi"
#include "auto/RSEG.fi"
#include "auto/RHIT.fi"
#include "auto/MIMP.fi"
#include "auto/TOPP.fi"

      data message_id_1 /1/,message_id_2 /1/,message_id_3 /1/
      data init /.false./
      save message_id_1,message_id_2,init,message_id_3

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
#include "auto/RTRA.ff"
#include "auto/RSEG.ff"
#include "auto/RHIT.ff"
#include "auto/MIMP.ff"
#include "auto/TOPP.ff"

       elec_corr = -1
*      --------------

      call mepric(message_id_3,0,
     +     'tfrfseg is obsolete - use rgfit instead')

      lsmoo = smooth_zfpar.eq.1 .or. niter_zfpar.gt.0

      istat = 0

      ift = 1

      if (l_diag) then
         print *,' tfrfseg starting for iseg=', iseg
         call tfwait()
      endif

*     **** get hits, sorted after decreasing z
      nzf_s = 0

*     **** initialize /zmh/ if needed
      call tusomh()

      do 30 iso=1,nzfmx_s
         if (iso.eq.1) then
            ind_rhit = prseg_rhit(iseg)
         else
            ind_rhit = xrseg_rhit(ind_rhit)
         endif
         if (ind_rhit.eq.0) go to 31
         rh = mrseg_rhit(ind_rhit)

*        **** get associated hits
         ih = orhit_hitb(rh)

         cmp = igede_cmp(ihitb_gede(ih))
         if (cmp.lt.1.or.cmp.gt.3) go to 30

         if (nzf_s.ge.nzfmx_s) then
            print *,' () tfrfseg: overflowing nzf_s=', nzf_s
            go to 30
         endif
         nzf_s = nzf_s + 1
         z_s(nzf_s) = fhitb_z(ih)
         hit_s(nzf_s) = ih
         rhit_s(nzf_s) = rh

#ifdef FULLPRINT
         if (iso.eq.1)
     +        print '(10x,4a8,a12)','iso','rh','ih','cmp','zhit'
         print '(10x,4i8,f12.2)',iso,rh,ih,cmp,z_s(nzf_s)
#endif
 30   continue
      print *,' () tfrfseg: overflowing nzf_s=',nzf_s
      istat = -10
      go to 999

 31   continue

      if (nzf_s.le.4) then
         print *,' tfrfseg: too few hits on segment ',iseg,
     +        ' :',nzf_s
         call mepric(message_id_1,10,
     +           'tfrfseg: too few hits on segment')

         istat = -10
         go to 999
      endif

*     **** sort again (to be sure)
      call sortzv(z_s,ind_s,nzf_s,+1,1,0)

*     **** print
      if (diag_level.ge.5) then
         write(*,'(2x,4a6,a8  ,2a9  ,2a8  ,''('',a8  ,'')'',a8  )')
     +     'ihit', 'isl', 'mimp', ' imc ',' z ', ' x0 ', ' y0 ', ' mx ',
     +        ' my ', ' myp ', ' p '

         do ii=1,nzf_s
            ih = hit_s(ind_s(ii))
            mimp = mimp_s(ind_s(ii))
            write(*,'(2x,4i6,f8.2,2f9.3,2f8.5,''('',f8.5,'')'',f8.3)')
     +           ih, ogede_gesl(ihitb_gede(ih)), mimp, omimp_mtra(mimp),
     +           fmimp_z(mimp), fmimp_x(mimp), fmimp_y(mimp),
     +           fmimp_tx(mimp), fmimp_ty(mimp),
     +           fmimp_ty(mimp)/sqrt(1.+fmimp_tx(mimp)**2),
     +           fmimp_p(mimp)
         enddo
      endif

*     **** iteration loop
      do iter=0,niter_zfpar

#ifdef FULLPRINT
         print *,' ******************************************* '
         print *,' *   iteration     ',iter,'                * '
         print *,' ******************************************* '
#endif

         do jzf=1,nzf_s         ! load the points
            ih = hit_s(ind_s(jzf))
            mimp = mimp_s(ind_s(jzf))
            hit_zf(jzf) = ih

            if (ih.lt.1.or.ih.gt.iq(jhitb+2)) then
               print *,' () tfrfseg: jzf,nzf_s,ih,iq(jhitb+2)=',
     +              jzf,nzf_s,ih,iq(jhitb+2)
            endif
            jpl = ihitb_gede(ih)
            plane_zf(jzf) = jpl
            if (diag_level.ge.5) then
               print *,' *******************'
               print *,' * tfrfseg: ih, jpl,isl,mimp=',
     +              ih, jpl,ogede_gesl(jpl),mimp
               print *,' *******************'
            endif
            if (igede_cmp(jpl).eq.2) then
               if (fhitb_q(hit_zf(jzf)).ge.0.) then
                  xsig = +1
               else
                  xsig = -1
               endif
            else
               xsig = 0
            endif

            z_zf(jzf) = fhitb_z(ih)

            sign_zf(jzf) = xsig

            if (jzf.eq.1) then

*              **** initialize prediction 
               xp_zf(1,jzf) = frseg_xe(iseg)
               xp_zf(2,jzf) = frseg_ye(iseg)
               xp_zf(3,jzf) = frseg_txe(iseg)
               xp_zf(4,jzf) = frseg_tye(iseg)
               xp_zf(5,jzf) = frseg_pf(iseg)

               do ii=1,5
                  do jj=1,5
                     cp_zf(ii,jj,jzf) = 0.
                  enddo
               enddo
               cp_zf(1,1,jzf)  = cxxrf_zfpar
               cp_zf(2,2,jzf)  = cyyrf_zfpar
               cp_zf(3,3,jzf) = ctxtxrf_zfpar
               cp_zf(4,4,jzf) = ctytyrf_zfpar
               cp_zf(5,5,jzf) = cqqrf_zfpar
*               cp_zf(5,5,jzf) = frseg_cvf(15,iseg) * 2.

            else
               izf = jzf - 1
               dz = z_zf(jzf) - z_zf(izf)

               call tftrans(dz,izf,jzf,f(1,1,jzf), ! prediction
     +              (elec_corr.eq.1),iter,istat)
               
               if (istat.lt.0) then

#if defined(STATVERBOSE)
                  print *,
     +                 ' tfrfseg: transport was impossible,',
     +                 ' abort fit for ',
     +                 'imc=', imc,' z1=', z_zf(izf), ' z2=', z_zf(jzf),
     +                 ' izf=',izf,
     +                 ' px,py,pz=', fmtra_px(imc), fmtra_py(imc),
     +                 fmtra_pz(imc)
#endif
                  call mepric(message_id_1,1,
     +               'tfrfseg: transport was impossible, abort track')
   
                  go to 999
               endif
            endif

            if (igede_cmp(jpl).eq.2) then ! projection
               xm_zf(1,jzf)   = xsig * abs( fhitb_q(ih) )
               cm_zf(1,1,jzf) = fhitb_r(ih)**2

*              **** tan(track angle) in uz-plane

               m_u = xp_zf(3,jzf) * cstot_plx(jpl)
     +             - xp_zf(4,jzf) * sntot_plx(jpl)
               cs_thetu = 1. / dsqrt(1.d0 + m_u**2)

*              **** distance from projection to wire (along u)
               xwire = fhitb_x(ih) / cstot_plx(jpl)
               du = (xp_zf(1,jzf) - xwire) * cstot_plx(jpl)
     +              - xp_zf(2,jzf) * sntot_plx(jpl)
               xm_p      = du * cs_thetu
*              **** difference to signed drift distance
               xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
               h_zf(1,1,jzf) =   cstot_plx(jpl) * cs_thetu
               h_zf(1,2,jzf) = - sntot_plx(jpl) * cs_thetu
               h_zf(1,3,jzf) = - du * m_u * cs_thetu**3
     +              * ( cstot_plx(jpl))
               h_zf(1,4,jzf) = - du * m_u * cs_thetu**3
     +              * (-sntot_plx(jpl))
               h_zf(1,5,jzf) = 0.
               hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
     +              +  h_zf(1,2,jzf)**2 * cp_zf(2,2,jzf)
     +              +  h_zf(1,3,jzf)**2 * cp_zf(3,3,jzf)
     +              +  h_zf(1,4,jzf)**2 * cp_zf(4,4,jzf)
     +              + 2.d0 * ( h_zf(1,1,jzf) * h_zf(1,2,jzf)
     +              * cp_zf(1,2,jzf)
     +              + h_zf(1,1,jzf) * h_zf(1,3,jzf) * cp_zf(1,3,jzf)
     +              + h_zf(1,1,jzf) * h_zf(1,4,jzf) * cp_zf(1,4,jzf)
     +              + h_zf(1,2,jzf) * h_zf(1,3,jzf) * cp_zf(2,3,jzf)
     +              + h_zf(1,2,jzf) * h_zf(1,4,jzf) * cp_zf(2,4,jzf)
     +              + h_zf(1,3,jzf) * h_zf(1,4,jzf) * cp_zf(3,4,jzf)
     +              )

               cr_p = fhitb_r(ih)**2 + hch
            elseif (igede_cmp(jpl).eq.1.or.igede_cmp(jpl).eq.3) then
               xwire = fhitb_x(ih)
               xm_zf(1,jzf)   = xwire
               cm_zf(1,1,jzf) = fhitb_r(ih)**2
               xm_p = xp_zf(1,jzf) * cstot_plx(jpl)
     +              - xp_zf(2,jzf) * sntot_plx(jpl)
               xr_p = xwire - xm_p

               h_zf(1,1,jzf) = cstot_plx(jpl)
               h_zf(1,2,jzf) = - sntot_plx(jpl)
               h_zf(1,3,jzf) = 0.
               h_zf(1,4,jzf) = 0.
               h_zf(1,5,jzf) = 0.
               hch = cp_zf(1,1,jzf) * h_zf(1,1,jzf)**2
     +              + 2.d0 * cp_zf(1,2,jzf)
     +              * h_zf(1,1,jzf) * h_zf(1,2,jzf)
     +              + cp_zf(2,2,jzf) * h_zf(1,2,jzf)**2
               cr_p = cm_zf(1,1,jzf) + hch
            else
               print *,' tfrfseg: non-supported type for jpl=', jpl,
     +              igede_cmp(jpl),' abort fit'
               go to 999
            endif
 
            if(dz.eq.0.) cr_p = 1.e10
*           -------------------------

            if (diag_level.ge.5) then
               print *,' tfrfseg: fhitb_x(ih), xm_p, xr_p, er_p=',
     +              fhitb_x(ih), xm_p, xr_p, dsqrt(cr_p)

               print *,' hch, fhitb_r(ih)**2, cr_p=',
     +              hch, fhitb_r(ih)**2, cr_p
            endif

*           **** filter point
            do ii=1,5
               kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +              + cp_zf(ii,2,jzf) * h_zf(1,2,jzf)
     +              + cp_zf(ii,3,jzf) * h_zf(1,3,jzf)
     +              + cp_zf(ii,4,jzf) * h_zf(1,4,jzf)
     +              + cp_zf(ii,5,jzf) * h_zf(1,5,jzf) ) / cr_p
            enddo

*           **** updated x value

            do ii=1,5
               xx_zf(ii,jzf) = xp_zf(ii,jzf) + kalman(ii,1) * xr_p
            enddo

*           **** constrain momentum parameter to allowed range
            if (abs(sngl(xx_zf(5,jzf))).gt.qplimit_zfpar) then
               qold = xx_zf(5,jzf)
               delta_q = kalman(5,1) * xr_p
               if (delta_q.ne.0.) then
                  f_corr = (sign(qplimit_zfpar,sngl(xx_zf(5,jzf)))
     +                 - xp_zf(5,jzf)) / delta_q
                  if (abs(f_corr).gt.1.) then
                     print *,' () tfrfseg: f_corr=',f_corr
                     f_corr = sign(1.,f_corr)
                  endif
                  do ii=1,5
                     kalman(ii,1) = kalman(ii,1) * f_corr
                     xx_zf(ii,jzf) = xp_zf(ii,jzf) + kalman(ii,1) * xr_p
                  enddo
               endif
            endif

*           **** updated cov matrix
            do ii=1,5
               do jj=1,5
                  cx_zf(ii,jj,jzf) = 0.
               enddo
            enddo

            do ii=1,5
               do jj=ii,5
                  sum = 0.
                  do kk=1,5
                     if (ii.eq.kk) then
                        sum = sum +
     +                       (1.d0 - kalman(ii,1)
     +                       * h_zf(1,kk,jzf)) * cp_zf(kk,jj,jzf)
                     else
                        sum = sum - kalman(ii,1)
     +                       * h_zf(1,kk,jzf) * cp_zf(kk,jj,jzf)
                     endif
                  enddo
                  cx_zf(ii,jj,jzf) = sum
                  if (ii.ne.jj) cx_zf(jj,ii,jzf) = sum
               enddo
            enddo

*           **** updated residual
            ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +           - h_zf(1,2,jzf) * kalman(2,1)
     +           - h_zf(1,3,jzf) * kalman(3,1)
     +           - h_zf(1,4,jzf) * kalman(4,1)
     +           - h_zf(1,5,jzf) * kalman(5,1)

            xr_zf(1,jzf) = xr_p * ihk
            cr_zf(1,1,jzf) = cm_zf(1,1,jzf) * ihk

*           **** updated chi2 contribution
            ch_zf(jzf) = xr_zf(1,jzf)**2 / cr_zf(1,1,jzf)

*           **** integer values
            if (jzf.eq.1) then
               nhit_zf(jzf) = 1
               cht_zf(jzf) = ch_zf(jzf)
               prev_zf(jzf) = 0
               pfault_zf(jzf) = 0
            else
               nhit_zf(jzf) = nhit_zf(izf) + 1
               cht_zf(jzf) = cht_zf(izf) + ch_zf(jzf)
               prev_zf(jzf) = izf
               pfault_zf(jzf) = fault_zf(izf)
            endif
            fault_zf(jzf) = 0
            dim_zf(jzf) = 1
            shadow_zf(jzf) = 0
            n_zf = jzf

*           **** fill candidate info
            if (jzf.eq.1) then
               nca_ft = 1
               ift = 1
               first_ft(ift) = 1
               prev_ft(ift) = 0
               nhit_ft(ift) = 1
               gen_ft(ift) = 1
               nfault_ft(ift)   = 0
               quality_ft(ift) = 1 - 0.05 * ch_zf(jzf)
               alive_ft(ift)    = .true.
               mature_ft(ift)   = .true.
               stat_ft(ift) = 2
            else
               nhit_ft(ift) = nhit_ft(ift) + 1
               last_ft(ift)     = jzf
               gen_ft(ift)      = gen_ft(ift) + 1
               quality_ft(ift)  = quality_ft(ift) + 1
     +              - 0.05 * ch_zf(jzf)
            endif
            if (diag_level.ge.6) then
               call tfl()
               call tfwait()
            endif
            if (jzf.eq.nzf_s) then
               if (diag_level.ge.5) call tfl()
               if (diag_level.ge.2) then
                  if (z_s(ind_s(1)).lt.400.) then
                     call tfparm(last_ft(ift))
                  else
                     call tfpar2(last_ft(ift))
                  endif
               endif
            endif
         enddo

         if (dabs(cx_zf(5,5,last_ft(ift))).lt.0.5*cqqrf_zfpar) then
            stat_ft(ift) = 4
         endif

#ifdef CHISTS
         if (iter.eq.0) then
            do izf=1,nzf_s
               call hfill(304,z_zf(izf),0.,sngl(dsqrt(cx_zf(1,1,izf))))
               call hfill(314,z_zf(izf),0.,1.)
            enddo
         endif
#endif

         if (.not.lsmoo) go to 100

         if (diag_level.ge.3) then
            do izf=1,n_zf
               print *,' izf,prev,z,x,tx=',
     +              izf,prev_zf(izf),z_zf(izf),xx_zf(1,izf),xx_zf(3,izf)
            enddo
         endif

*        **** backward-smoother
         if (diag_level.ge.3)
     +        print *,' start smoothing ----------------------------->'

         izf = nzf_s            ! copy last hit to smoother array
         do ii=1,5
            xs_zf(ii,izf) = xx_zf(ii,izf)
            do jj=1,5
               cs_zf(ii,jj,izf) = cx_zf(ii,jj,izf)
            enddo
         enddo

         do izf=nzf_s-1,1,-1
            jzf = izf + 1
**            print *,' ----> smooth from ',jzf,' to ', izf

*           **** transport distance
            dz = z_zf(jzf) - z_zf(izf)
            if (dz.gt.0.2d0) then
               print *,' () tfrfseg: dz=', dz,' planes=', 
     +              plane_zf(izf),plane_zf(jzf)
               istat = -1
               go to 999
            endif

*           **** construct gain matrix ak
            do ii=1,5
               do jj=1,5
                  dppi(ii,jj) = cp_zf(ii,jj,jzf)
               enddo
            enddo
            call dsinv(5,dppi,5,ifail)
            if (ifail.ne.0) then
               print *,' () tfrfseg: ifail=',ifail
**               print *,'           matrix=',((dppi(ii,jj),ii=1,4),
**     +              jj=1,4)
               print *,'    skip smoothing for ift=', ift,' jzf=', jzf
               stat_ft(ift) = 2
               go to 999
            endif

            do ii=1,5
               do jj=1,5
                  sum = 0.
                  do kk=1,5
                     do ll=1,5
                        sum = sum + cx_zf(ii,kk,izf) * f(ll,kk,jzf)
     +                       * dppi(ll,jj)
                     enddo
                  enddo
                  ak(ii,jj) = sum
               enddo
            enddo

*           **** calculate smoothed parameters
            do ii=1,5
               sum = 0.
               do jj=1,5
                  sum = sum
     +                 + ak(ii,jj) * (xs_zf(jj,jzf) - xp_zf(jj,jzf))
               enddo
               xs_zf(ii,izf) = xx_zf(ii,izf) + sum
            enddo

**            print *,'     ----> line ',izf,' xs_zf=',
**     +           (xs_zf(ii,izf),ii=1,5)

*           **** cov matrix of smoothed parameters
            do ii=1,5
               do jj=1,5
                  sum = 0.
                  do kk=1,5
                     do ll=1,5
                        sum = sum + ak(ii,kk)
     +                       * (cs_zf(kk,ll,jzf) - cp_zf(kk,ll,jzf))
     +                       * ak(jj,ll)
                     enddo
                  enddo
                  cs_zf(ii,jj,izf) = cx_zf(ii,jj,izf) + sum
               enddo
            enddo

*           **** projection of smoothed vector
            ih  = hit_zf(izf)
            jpl = plane_zf(izf)
            xsig = sign_zf(izf)

            if (igede_cmp(jpl).eq.2) then
               xm_zf(1,izf)   = xsig * abs( fhitb_q(ih) )
               cm_zf(1,1,izf) = fhitb_r(ih)**2
*              **** tan(track angle) in uz-plane

               m_u = xs_zf(3,izf) * cstot_plx(jpl)
     +             - xs_zf(4,izf) * sntot_plx(jpl)
               cs_thetu = 1. / dsqrt(1.d0 + m_u**2)

*              **** distance from projection to wire (along u)
               xwire = fhitb_x(ih) / cstot_plx(jpl)
               du = (xs_zf(1,izf) - xwire) * cstot_plx(jpl)
     +              - xs_zf(2,izf) * sntot_plx(jpl)
               xm_p      = du * cs_thetu
*              **** difference to signed drift distance
               xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
               h_zf(1,1,izf) =   cstot_plx(jpl) * cs_thetu
               h_zf(1,2,izf) = - sntot_plx(jpl) * cs_thetu
               h_zf(1,3,izf) = - du * m_u * cs_thetu**3
     +              * ( cstot_plx(jpl))
               h_zf(1,4,izf) = - du * m_u * cs_thetu**3
     +              * (-sntot_plx(jpl))
               h_zf(1,5,izf) = 0.
            elseif (igede_cmp(jpl).eq.1.or.igede_cmp(jpl).eq.3) then
               xwire = fhitb_x(ih)
               xm_zf(1,izf)   = xwire
               cm_zf(1,1,izf) = fhitb_r(ih)**2
               xm_p = xs_zf(1,izf) * cstot_plx(jpl)
     +              - xs_zf(2,izf) * sntot_plx(jpl)
               xr_p = xwire - xm_p

               h_zf(1,1,izf) = cstot_plx(jpl)
               h_zf(1,2,izf) = - sntot_plx(jpl)
               h_zf(1,3,izf) = 0.
               h_zf(1,4,izf) = 0.
               h_zf(1,5,izf) = 0.
            else
               print *,' tfrfseg: non-supported type for jpl=', jpl,
     +              igede_cmp(jpl)
               istat = -1
               go to 999
            endif

*           **** update of residuals etc
            xr_zf(1,izf) = xr_p
            do ii=1,5
               do jj=1,5
                  do kk=1,5
                     do ll=1,5
                        cr_zf(1,1,izf) = cr_zf(1,1,izf) - h_zf(1,ii,izf)
     +                       * ak(ii,jj)
     +                       * (cs_zf(jj,kk,jzf) - cp_zf(jj,kk,jzf))
     +                       * ak(ll,kk) * h_zf(1,ll,izf)
                     enddo
                  enddo
               enddo
            enddo
            if (cr_zf(1,1,izf).le.0.d0) then
               print *,' () tfrfseg: smoothed resid cov .le.0.:',
     +              cr_zf(1,1,izf)
               ch_zf(izf) = 0.
            else
               ch_zf(izf) = xr_zf(1,izf)**2/cr_zf(1,1,izf)
            endif

            if (diag_level.ge.3) then
               print '(i3,4f10.3,4f10.3)',izf, (xs_zf(ii,izf),ii=1,4),
     +              (dsqrt(cs_zf(ii,ii,izf)),ii=1,4)
            endif
         enddo                  ! loop over hits

      enddo ! iter loop

*     **** fill total chi**2s
      do izf=1,nzf_s
         if (izf.eq.1) then
            cht_zf(izf) = ch_zf(izf)
            prevs_zf(izf) = 0
         else
            cht_zf(izf) = cht_zf(izf-1) + ch_zf(izf)
            prevs_zf(izf) = izf - 1
         endif
      enddo

*     **** smoothed candidate info
      if (stat_ft(ift).eq.2) then
         stat_ft(ift) = 3
      else
         stat_ft(ift) = 5
      endif

 100  continue
#ifdef CHISTS
      do izf=1,nzf_s
         call hfill(303,z_zf(izf),0.,ch_zf(izf))
         call hfill(313,z_zf(izf),0.,1.)
         if (stat_ft(ift).eq.3.or.stat_ft(ift).eq.5) then
            call hfill(305,z_zf(izf),0.,sngl(dsqrt(cs_zf(1,1,izf))))
            call hfill(315,z_zf(izf),0.,1.)
         endif
      enddo
#endif

      call tfsttra(ift)
      if (l_diag) call tfwait()

 999  end
