*-- Author:    A.Spiridonov    06/07/01  
*-- change:
*   inr_zf(izf) = 1                                    20/07/01 A. Spiridonov
*   correct setting of plane_zf(izf)                   21/07/01 A. Spiridonov

*#define DEBUG_TFRSEGFT

      subroutine tfrsegft(iseg,ift,if_error)

*     **** transform PC segment iseg into ft-cantidate ift
*          if_error.ne.0 - OK
* 
      implicit none

      double precision covi(5,5)
      real pa(5), pamc(5), dpa(5), ch2mc, ex(5), dpanorm(5), zref
      integer i, j, ndf, ifail, mimp, jaux, assmimp, istat, i_pack, ii,
     +     iseg, edge, imc, hf, ih, icode, ift, izf

      integer nzfmx_s
      parameter (nzfmx_s=300)
      integer rh,iso,ind_rhit,mc,imimp,nimimp,cmp
      real z_test

      real charge, mass, corc(5,5), cms, tx, ty

      character*20 cname

      integer n_rhit,if_error,rhit,rhit_s(nzfmx_s)

      integer dom_tc,dom,dw,dl,sl
      integer rgnamdom,rgwidlent,maxwin,nwin,iiwin
      parameter (maxwin=40)
      integer vecwin(maxwin)
      real rgwizmax
      real xmin,xmax,ymin,ymax

      real x_tc,y_tc,ex_tc,ey_tc,e_tc(5,5),zdl

      double precision c11 , c12 , c13 , c14 , c15
      double precision       c22 , c23 , c24 , c25
      double precision             c33 , c34 , c35
      double precision                   c44 , c45
      double precision                         c55

      double precision x,y,d_z,sum

#include "arte/Arte.fi"
#include "rang/zfpar.fi"
#include "rang/zf.fi"

#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/RHIT.fi"
#include "auto/RTRA.fi"
#include "auto/RSEG.fi"
#include "auto/MTRA.fi"
#include "auto/GEO.fi"
#include "auto/TOPP.fi"

#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/RHIT.ff"
#include "auto/RTRA.ff"
#include "auto/RSEG.ff"
#include "auto/MTRA.ff"
#include "auto/GEO.ff"
#include "auto/TOPP.ff"

      istat = 3
*   -----------
      ndf = 4
*   -----------

      n_rhit = 0

      do 30 iso=1,nzfmx_s
         if (iso.eq.1) then
            ind_rhit = prseg_rhit(iseg)
         else
            ind_rhit = xrseg_rhit(ind_rhit)
         endif
         if (ind_rhit.eq.0) go to 31
         rh = mrseg_rhit(ind_rhit)

*        **** get associated hits

         ih = orhit_hitb(rh)

         cmp = igede_cmp(ihitb_gede(ih))

         n_rhit = n_rhit + 1

#ifdef DEBUG_TFRSEGFT
         print *,'tfrsegft : nr,rh,ih,cmp,z '
     +        ,n_rhit,rh,ih,cmp,fhitb_z(ih)
#endif

         rhit_s(n_rhit) = rh

 30   continue
 31   continue                  !  last RHIT

      if(n_rhit.lt.1) then
         print *,' () tfrsegf: overflowing n_rhit=',n_rhit
         if_error = -1
         go to 999
      end if
      
      if(n_zf+1.gt.nzfmx) then
         print *,' () tfrsegf: overflowing n_zf=',n_zf
         if_error = -1
         go to 999
      end if

      do 10 rhit=n_rhit,1,-1
         rh = rhit_s(rhit)
         ih = orhit_hitb(rh)

         n_zf = n_zf + 1
         izf = n_zf
         
         z_zf(izf) = fhitb_z(ih)
         hit_zf(izf) = ih
         plane_zf(izf) = ihitb_gede(ih)
         nhit_zf(izf) = n_rhit - rhit + 1
         if(frhit_q(rh).lt.0.) then
            sign_zf(izf) = -1 
         else
            sign_zf(izf) = +1
         end if

         inr_zf(izf) = 1

         if(rhit.eq.n_rhit) then                  !   first   RHIT
         
            if(nca_ft+1.gt.ncamx) then       
               print *,' () tfrsegf: overflowing nca_ft=',nca_ft
               if_error = -1
               go to 999
            end if

            xs_zf(1,izf) = frseg_xe(iseg)
            xs_zf(2,izf) = frseg_ye(iseg)
            xs_zf(3,izf) = frseg_txe(iseg)
            xs_zf(4,izf) = frseg_tye(iseg)
            xs_zf(5,izf) = frseg_pe(iseg)

            do i=1,5
               do j=1,5
                  cs_zf(i,j,izf) = frseg_cve(matrix_pack(i,j),iseg)
               end do
            end do 

            prevs_zf(izf) = 0

            nca_ft = nca_ft + 1
            ift = nca_ft

            first_ft(ift) = izf
            last_ft(ift) = izf
            prev_ft(ift) = 0
            nhit_ft(ift) = n_rhit
            nfault_ft(ift) = 0
            quality_ft(ift) = n_rhit
            stat_ft(ift) = istat
            alive_ft(ift) = .true.
            mature_ft(ift) = .false.

         else if(rhit.lt.n_rhit) then   ! intermediate RHIT
            
            xs_zf(1,izf) = frhit_x(rh)
            xs_zf(2,izf) = frhit_y(rh)
            xs_zf(3,izf) = frhit_tx(rh)
            xs_zf(4,izf) = frhit_ty(rh)
            xs_zf(5,izf) = frhit_p(rh)

            prevs_zf(izf) = izf - 1

            last_ft(ift) = izf
            nhit_ft(ift) = n_rhit - rhit + 1

         end if

 10   continue

*     last rhit

      xs_zf(1,izf) = frseg_xf(iseg)
      xs_zf(2,izf) = frseg_yf(iseg)
      xs_zf(3,izf) = frseg_txf(iseg)
      xs_zf(4,izf) = frseg_tyf(iseg)
      xs_zf(5,izf) = frseg_pf(iseg)
      
      do i=1,5
         do j=1,5
            cs_zf(i,j,izf) = frseg_cvf(matrix_pack(i,j),iseg)
         end do
      end do 

**    define domain
      
      if(z_zf(izf).gt.683..and.z_zf(izf).lt.727.) dom_tc=rgnamdom('PC1')
      if(z_zf(izf).gt.732..and.z_zf(izf).lt.764.) dom_tc=rgnamdom('PC2')
      if(z_zf(izf).gt.768..and.z_zf(izf).lt.800.) dom_tc=rgnamdom('PC3')
      if(z_zf(izf).gt.804..and.z_zf(izf).lt.850.) dom_tc=rgnamdom('PC4')

#ifdef DEBUG_TFRSEGFT
      print *,'tfrsegft: dom_tc ',dom_tc
#endif

      call rgdomwin(dom_tc,maxwin,vecwin,nwin)

#ifdef DEBUG_TFRSEGFT
      print *,'tfrsegft: maxwin,nwin ',maxwin,nwin
#endif

*     **** search domain

      do 20 iiwin=1,nwin
         dw = vecwin(iiwin)
**         dl = rgwidlent(dw,-1) ! upstream 
         dl = rgwidlent(dw,+1) ! upstream 
         zdl = rgwizmax(dw)
         call rgwibord(dw,xmin,xmax,ymin,ymax)

*        ***** extrapolate to domain window

         x_tc = xs_zf(1,izf) + (zdl - z_zf(izf)) *  xs_zf(3,izf)
         y_tc = xs_zf(2,izf) + (zdl - z_zf(izf)) *  xs_zf(4,izf)

*        ***** x error extrapolation    

        d_z = ( zdl - z_zf(izf))
        c11 = cs_zf(1,1,izf)
        c13 = cs_zf(1,3,izf)
        c33 = cs_zf(3,3,izf)
        ex_tc = c11 + 2. * d_z * c13 + d_z * d_z * c33 
        ex_tc = sqrt( ex_tc ) * 3.

#ifdef dmdebug

         print *,'tested domain '
         print *,' dl=',dl,' dw=',dw,' xmin/x/xmax=',
     +        xmin,x_tc,xmax
         print *,' dl=',dl,' dw=',dw,' ymin/y/ymax=',
     +        ymin,y_tc,ymax
#endif


         if ((x_tc+ex_tc).lt.xmin) go to 20
         if ((x_tc-ex_tc).gt.xmax) go to 20

*        ***** y error extrapolation    

        c22 = cs_zf(2,2,izf)
        c24 = cs_zf(2,4,izf)
        c44 = cs_zf(4,4,izf)
        ey_tc = c22 + 2. * d_z * c24 + d_z * d_z * c44 
        ey_tc = sqrt( ey_tc ) * 3.

         if ((y_tc+ey_tc).lt.ymin) go to 20
         if ((y_tc-ey_tc).gt.ymax) go to 20

#ifdef DOMAIN_TEST
         print *,' -- accepted domain'
         print  '(" d_z ",f8.3," mixma ex",3(1x,f8.3), "ex ",e11.4)'
     +          ,d_z,xmin,x_tc,xmax,ex_tc
         print  '(" d_z ",f8.3," miyma",3(1x,f8.3), "ey ",e11.4)'
     +          ,d_z,ymin,y_tc,ymax,ey_tc
#endif

         domlay_zf(izf) = dl
**         plane_zf(izf) = ihitb_gede(ih)
         ch_zf(izf) = 0.
         fault_zf(izf) = 0
*     go to 21

 20      continue
 21      continue


*%%%
**      call tfauxdft(ift)

 999  end
