////////////////////////////////////////////////////////////////
//
// Author: D.Dujmic
//
// Particle ID using RICH stand-alone ring reconstruction. 
// - rc99idRISE(float ip, float rad, float *dd) returns deviations
//   in sigma^2
// Code returns: 0...4 best hypothesis
//               -1 no reliable hypothesis
//
// Modifications:
//   May 29, 2000 (DD): calculation moved to RingSearchARTE
//   Jun 09, 2000 (DD): Global parameters restored, 
//                 rc99idRISE(ArtePointer<RTRA> t) removed
//
////////////////////////////////////////////////////////////////

#include "arte/arte.hh"
#include "rise/RingSearchARTE.h"

// deviations in sigma^2 -> dd
int rc99idRISE(float ip, float radius, float *dd) {
  if (!RICH_Search) RICH_Search = new RingSearchARTE;
  RingSearchTrack::ip              = ip;
  bool old1=RingSearchAttrib::use_simple_R2P2;
  bool old2=RingSearchAttrib::fillrtra;
  bool old3=RingSearchAttrib::id;
  RingSearchAttrib::use_simple_R2P2= true;
  RingSearchAttrib::fillrtra       = false;
  RingSearchAttrib::id             = true;
  RICH_Search->makeR2P2lines();
  int ret=RICH_Search->R2P2likelihood(radius);
  dd=RICH_Search->GetLr();
  RingSearchAttrib::use_simple_R2P2= old1;
  RingSearchAttrib::fillrtra       = old2;
  RingSearchAttrib::id             = old3;
  return ret;
}

