// ********************************************************************
//
// source:    ecalstep2
//
//
// created:   18-01-01
// modified:  
//
// author:    Mauro Villa
//
//  This routine assumes to have in input an RTRA bank 
//  filled with VDS-OTR matches and an RCCL as obtained by careevnt1
//
//  It prolongates the FITTED rtras to ECAL and it performs step 2 of
//  ECAL reconstruction (that is: find MIP signals, distinguish between
//  charged and neutral clusters and it stores back an RCCL table).
//  Then it sets all the relations for the matched clusters.
//
//
// ********************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ARTE includes
#include "arte/arte.hh"
#include "arte/Chrono.hh"
#include "arte/ChronoManager.hh"

// functions
extern "C" void careevnt2_();
void            matchRtraCare();
void            rcRcclRtra();

extern Chrono *cron_rcECAL2;

void rcEcalStep2()
{
  cron_rcECAL2->start();
  // ******************************************************************  
  // Step 1: Select the tracks (RTRA entries) for VDS-OTR
  //
  matchRtraCare(); 

  // ******************************************************************
  // Step 2: Perform the care event 2
  //
  careevnt2_();
  // ******************************************************************
  // Step 3: Fill all the available relations
  //
  rcRcclRtra();
  //
  // Timing
  //
  cron_rcECAL2->stop();
  static int counts = 0;
  static float time_rcECAL2 =0.0;
  time_rcECAL2 += cron_rcECAL2->lastTime();
  counts++;
  if( (counts %100)==0 ){ 
    cout<<"ECAL2 time:"<<time_rcECAL2/counts<<endl;
  }
}
