// ********************************************************************
//
//  Routine:      rcHITBtoLocal
//
//  Description:  transforms HITB to local or global coordinates
//                implemented only for VDS so far
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"


//*****************************************************************
// function
//*****************************************************************

int rcHITBtoLocal(const int cmp, const int level) {

const int indexARTE[3][3] = {{0, 3,  6},
                             {1, 4,  7},
                             {2, 5,  8}};


  if (cmp != 1) return -1;

//==================================================================
// 1. transformation to local coordinates, store global coordinates
//==================================================================

  static float * HITBx;
  //  static float * HITBy;
  //  static float * HITBz;


  if (level ==0){

//==================================================================
// 1a. count hits and allocate space for hit buffer
//==================================================================

   int nHITB = 0;

   for( ArteTable<HITB>::iterator hitb = ArteTable<HITB>::begin();
        hitb != ArteTable<HITB>::end(); ++hitb ) {
    if ((*hitb)->gede->cmp == 1) nHITB++;
   };

   HITBx  = new float[nHITB];
   //   HITBy  = new float[nHITB];
   //   HITBz  = new float[nHITB];

//==================================================================
// 1b. store global coordinates and do a transformation to local 
//     coordinates
//     only implemented for the VDS so far
//==================================================================

   nHITB = 0;

   for( ArteTable<GEDE>::iterator gede = ArteTable<GEDE>::begin();
        gede != ArteTable<GEDE>::end(); ++gede ) {

    ArteTable<HITB>::iterator hitb1(gede->hit1);
    ArteTable<HITB>::iterator hitbl(gede->hitl);

    int diff = *hitbl - *hitb1;

    if (gede->cmp == cmp && diff >= 0) {

//==================================================================
// 1b. get the transformation vector for this plane
//==================================================================

   float drRot[3] = {0.0,0.0,0.0};
   float GEDErotnew[3][3];

   for (int i=0; i<3; i++){for (int j=0; j<3; j++){
       GEDErotnew[i][j]    = gede->rot[indexARTE[i][j]];
   };};


   for( ArteTable<ACGA>::iterator acga = ArteTable<ACGA>::begin();
       acga != ArteTable<ACGA>::end(); ++acga ) {

    if ((*acga)->cmp == gede->cmp){

       float deltaz, dr[3];

       deltaz = 0.5*(gede->zmin+gede->zmax) - (*acga)->z;

       dr[0] = (*acga)->dx + (*acga)->dtx * deltaz;
       dr[1] = (*acga)->dy + (*acga)->dty * deltaz;
       dr[2] = (*acga)->dz;

       for (int i=0; i<3; i++){
        drRot[i] = 0.0;
        for (int j=0; j<3; j++){
        drRot[i] = drRot[i] + GEDErotnew[i][j] * dr[j];
       };};

    };
   };

    float sxmnLocal, symnLocal;

    sxmnLocal = gede->sxmn - drRot[0];
    symnLocal = gede->symn - drRot[1];

//==================================================================
// 1b. get the transformation vector for this plane
//==================================================================


   int test = 0;

   for( ArteTable<HITB>::iterator hitb(gede->hit1);
        test == 0 ; ++hitb ) {

     if (hitb == ArteTable<HITB>::iterator(gede->hitl)) test = 1;

     HITBx[nHITB] = hitb->x;
     //     HITBy[nHITB] = hitb->y;
     //     HITBz[nHITB] = hitb->z;
     nHITB++;

     hitb->x = hitb->x - gede->xfw[0] + 
               gede->cos * sxmnLocal - gede->sin * symnLocal + gede->xfw[1];

   };

  };
  };
//==================================================================
// 2. transformation to global coordinates
//==================================================================

  } else {

   int nHITB = 0;

   for( ArteTable<GEDE>::iterator gede = ArteTable<GEDE>::begin();
        gede != ArteTable<GEDE>::end(); ++gede ) {

    ArteTable<HITB>::iterator hitb1(gede->hit1);
    ArteTable<HITB>::iterator hitbl(gede->hitl);

    int diff = *hitbl - *hitb1;

    if (gede->cmp == cmp && diff >= 0) {

   int test = 0;

   for( ArteTable<HITB>::iterator hitb(gede->hit1);
        test == 0 ; ++hitb ) {

     if (hitb == ArteTable<HITB>::iterator(gede->hitl)) test = 1;

     hitb->x = HITBx[nHITB];
     //     hitb->y = HITBy[nHITB];
     //     hitb->z = HITBz[nHITB];

     nHITB++;

   };


   };};

   delete[] HITBx;
   //   delete[] HITBy;
   //   delete[] HITBz;

 };
     return 0;

};
