
//*****************************************************************************
// 
// Author:  Rainer Mankel
//          Humboldt University Berlin
//          mankel@ifh.de
//
// Created: 02 Mar 1999
//
// Versions history:
//
// 1.03/01 - add detailed timing (stored in EVTI) (AG)
//
// 1.03/00 - storage of neutrals added, bremsstrahlung correction foreseen.
//           Matching VDS/main tracker added.
//
// 1.02/03 - Jpsi vertex search removed in rcvert()
//
// 1.02/02 - track-based muon reco added
//
// 1.02/01 - call to RITER and VDS pattern recognition (cats,holmes)
//           added
//
// 1.02/00 - RICH reconstruction added. Reconstruction options.
//
// 1.01/00 - matching between tracks and reconstructed ECAL 
//           clusters added (using matchRsegCare). 
//    	     A first simple electron identification (rcelid.C)
//           was added & included in rcevnt. rcinit.C added
//           for module initialization.  (2-Mar-99)
//
// 1.00/00 - first version of default reconstruction, includes
//           ideal VDS reconstruction, main tracker reconstruction,
//           ideal matching and full refit.
//
// Changes:
// 25 May 2000 (AG) add ARTE_mark()
// 14 May 2000 (AG) more ARTE_mark()
// 16 Jun 2000 (AG) polishing
// 25 Jul 2000 (AG) added classification initialization
// 03 Aug 2000 (AG) added printout of classes
// 10 Nov 2000 (AG) updated classification bit handling
// 15 Nov 2000 (AG) added global classification flag and move classSum
//  5 Oct 2001 (DS) obsolete recoOptions are removed
//
//*****************************************************************************

// standard includes
#include <iostream.h>

// ARTE includes
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "reco/eclass.hh"
#include "farm/farm.hh"

// externals
extern int         FADEB;    // debug flag

// prototypes
int SvdInit();

//
// program code
//
extern "C" void
rcinit_()
{
  // mark
  ARTE_mark( "rcinit_ 0", 0 );
  cout << "rcinit_" << endl;

  // inits
  static int init = 0;
  if( !init ){
    init = 1;
    
    // message
    arteMsg << "HERA-B reconstruction version 1.03/01";
    arteMsg.warn();
    
    // SVD
    ARTE_mark( "SvdInit", 0 );
    SvdInit();
  }

  // mark
  ARTE_mark( "rcinit_ 1", 0 );
}
