//--*-C++-*--
//
//  Created: May 11 2001
//
//  Modifications:
//
//  23 May 2001 (DD) okL added
//  27 Jun 2001 (DD) alternative track selection added
//  09 Jul 2001  DD  tuney added for signal yield tuning
//  14 Jul 2001  dd  seed sigma enhanement added
//
#ifndef _RATTRIBUTE_H_
#define _RATTRIBUTE_H_

class RAttribute {
 public:
  /// Verbosity level
  static int   verb;
  /// Width of search area
  static float deltaR;
  /// Fit radius or not
  static bool  fitR;
  /// Fit horizontal direction or not
  static bool  fitX;
  /// Fit vertical direction or not
  static bool  fitY;
  /// Normalize likelihoods
  static bool  normL;
  /// Probability type
  static int   probType;
  /// Probability type for global fit
  static int   probTypeGlobal;
  /// Make global fit or not
  static bool globalFit;
  /// Maximum number of iterations
  static int maxIter;
  /// MC smearing of seed tracks (tx)
  static float smearx;
  /// MC smearing of seed tracks (ty)
  static float smeary;
  /// Maximum allowed radius in fit
  static float maxR;
  /// Minimum likelihood for accepted rings
  static float minL;
  /// Minimum likelihood for positive identification
  static float okL;
  /// Minimum hits in ROI
  static int minROI;
  /// Type of track-seed selection
  static int track;
  /// Print attributes
  static void print();
  /// Tune yield to account for lower reco efficiency
  static float tuney;
  /// Enhancement factor for seed sigma tx
  static float enhtx;
  /// Enhancement factor for seed sigma ty
  static float enhty;
};

#endif
