#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <sys/stat.h>

#include "trigger_format.h"
#include "l2trigtab.h"
#include "rpm.h"
#include "grr.h"
/*#include "slt.h"*/
#include "errno.h"

extern char Key[20];
extern int errno;
extern int  nArg;
extern char **vArg;

static int MakeTT(int ** l2tt,int * length, int major, int minor);

int L2TTFormat(int ** l2tt,int * length, int major, int minor)
{
  int *l2formtt;
  int size;
  char mess[200];


  if(MakeTT(&l2formtt,&size,major,minor)!=0){
     sprintf(mess,"L2TTFormat: MakeTT failed !\n");
     grr_error(GRR_SFATAL,mess,1);
     return 1;
  }
  *l2tt = l2formtt;
  *length = size;

  /*printf("L2TTFormat: size of symbol table %d \n", *length);*/

  return 0;
}


static int MakeTT(int ** l2tt,int * length, int major, int minor) {

  L2TENTRY *theTab;
  int nEntries;
  int rc;
  L2FORMTHEAD *header;
  char *wrPtr;
  int flag = 0;
  int dump = 0;
  int i;
  char mess[200];
  FILE *fdout;
  char fName[100];
  char ModeName[10];

  // TERESA: the key has to be different in case of running offline (0 online)

  rc = L2TT_ReadFromDB("/SLT_SETUP", 0, &theTab, &nEntries, major, minor);

  *l2tt = (int*) malloc(sizeof(L2FORMTHEAD)+nEntries*sizeof(L2TENTRY));
  *length = sizeof(L2FORMTHEAD)+nEntries*sizeof(L2TENTRY);

  if(l2tt != NULL){
     header = (L2FORMTHEAD *) *l2tt;
     header->nentries = nEntries;
     wrPtr = (char*) (header + 1);
     memcpy((L2TENTRY*)wrPtr, theTab, sizeof(L2TENTRY)*nEntries);
     flag = 0;
  }
  else{
    sprintf(mess,"L2TTFormat/MakeTT: 
                  couldn't allocate space for trigger table \n");
    grr_error(GRR_SFATAL,mess,1);
    flag = 1;
    return flag;
  }
  
  /* decode the SltDumpMode to be used for the L2tabs */
  for( i=1; i<nArg; i++ ){
    if( !strncmp( vArg[i], "-sltdumpmode:", 13 ) ){
      strcpy(ModeName, vArg[i]+13);
      sprintf(mess,"L2FormArte/MakeTT: sltdumpmode %s\n",ModeName);
      grr_error(GRR_SINFO,mess,0); 
    } 
  }
  if (!strncmp(ModeName,"ASCII",5)){

    for( i=1; i<nArg; i++ ){
      if( !strncmp( vArg[i], "-sltdumpdir:", 12 ) ){
	dump++;
	strcpy(fName, vArg[i]+12);
	sprintf(mess,"\nL2STFormat/MakeST: dumping the L2 Trigger Table (l2tt.txt) to %s\n",fName);
	grr_error(GRR_SINFO,mess,0); 
      } 
    }
    if (dump == 0) {
      sprintf(mess,"\nL2FormArte/Write_BuffMapAscii: Couldn't read address of sltdumpdir directory\n");
      grr_error(GRR_SERROR,mess,0);
    } 
    strcat(fName,"l2tt.txt_");
    strcat(fName,Key);
    umask(0111);

    /*    open file for trigger table trigger information: ---------------- */
    fdout = fopen(fName, "w");
    if( fdout == NULL) {
      sprintf(mess,"L2FormArte/MakeST: unable to open %s\n",fName);
      grr_error(GRR_SERROR,mess,1);
      sprintf(mess,"L2FormArte/MakeST: error %s\n",strerror(errno));
      grr_error(GRR_SERROR,mess,1);
      flag = 1;
    } else {
      rc = L2TT_WriteToFile(fName, theTab, nEntries);

      if(rc != GRR_OK) {
	sprintf(mess,"L2FormArte/L2TTFormat: Problems to write ASCii file (l2tt.txt)");
	grr_error(GRR_SERROR,mess,0);
      } else {
	sprintf(mess,"L2FormArte/L2TTFormat: ASCii file (l2tt.txt ) generated");
	grr_error(GRR_SINFO,mess,0);
      }  

      fclose(fdout);
      flag = 0;
    }
  } else {
    sprintf(mess,"L2FormArte/MakeTT: NO SLT trigger type table will be dumped !!!\n");
    grr_error(GRR_SINFO,mess,0);
  }
  return flag;

}
 






