******************************************************************************
*
* source:    sltsimkuip.cdf
*
* type:      KUIP source code
*
* created:   24 Nov 2000
*	
* author:    Andreas Gellrich,  E-mail: Andreas.Gellrich@desy.de
*            Lars Soezueer <soezueer@mail.desy.de>
*
* purpose:   define KUIP commands for SLT/SIM
*
* hints:     
*
* changes:
* 24 Nov 2000 (AG) creation
* 16 Mar 2001 (LS) added Menu SIM with commands path, file and debuglevel
* 15 Oct 2001 (LS) added commands setpar, unsetpar, showpar
*
******************************************************************************

>NAME sltsimkuip

>MENU /SLT/SIM
>GUIDANCE
Commands for the simulation of the Second Level Trigger.

>COMMAND path
>PARAMETERS
NAME 'EDC path name' C D='/afs/desy.de/group/hera-b/SLT/Rev0603/Linux_intel_glibc/bin/'
>GUIDANCE
Define the path to the EDC (Second Level Process Emulator) executable.
.
Must not contain the name of the executable itself.
Define that by the command SLT/SIM/file
Default is 
>ACTION slt_sim_path%C

>COMMAND file
>PARAMETERS
NAME 'EDC file name' C D='sltsim2000'
>GUIDANCE
Define the file name of the EDC (Second Level Process Emulator) executable.
.
Must not contain the path to the executable.
Define that by the command SLT/SIM/path
>ACTION slt_sim_file%C

>COMMAND runnumber
>PARAMETERS
RUNNUMBER 'runnumber' I
>GUIDANCE
Set the number of the run, whose Second Level settings
(geometry, buffer map, trigger type and symbol table)
are given to the emulator.
>ACTION slt_sim_runnumber%C

>COMMAND debuglevel
>PARAMETERS
LEVEL 'EDC debug level' I D=0 R=0:3
>GUIDANCE
Set the debug level for the EDC (Second Level Process Emulator) process.
.
Possible values are:
  0 (default) No debug output, no error logger window.
  1           Error logger window, but no debug information.
  2           Error logger window, some debug information.
  3           Error logger window, lots of debug information.
>ACTION slt_sim_debuglevel%C

>COMMAND setpar
>PARAMETERS
PARAM 'SLP parameter name' C
+
VALUE 'SLP parameter value' C
>GUIDANCE
Set an SLP parameter, to a value if given,
or modify the default value of an SLP parameter.
.
Examples:
.
/SLT/SIM/SETPAR -TGStrigMode: 1
.
/SLT/SIM/SETPAR -SLPNoSMC
.
/SLT/SIM/SETPAR +P vds-itr.iol
>ACTION slt_sim_setpar%C

>COMMAND unsetpar
>PARAMETERS
PARAM 'SLP parameter name' C
>GUIDANCE
Remove an SLP parameter from the parameter list
which will be given to the SLP executable.
>ACTION slt_sim_unsetpar%C

>COMMAND showpar
>GUIDANCE
Show current setting of SLP parameters
>ACTION slt_sim_showpar%C

