!-----------------------------------------------------------------------
! write the results to RSEG, RHIT, RPNT, update HITB
! M. Staric, jan-2001
!-----------------------------------------------------------------------


      SUBROUTINE TEMA_PUT_RSEG

      IMPLICIT NONE

#include "tema/TEMA_RSEG.fi"
#include "arte/Arte.fi"
      INTEGER ISEG              ! segment index (/TEMA_RSEG/)
      INTEGER IROW              ! segment row in table RSEG
      INTEGER CMP               ! component bits 
#include "arte/Arte.ff"

      DO ISEG=1,NSEG
         IF(FIT_SEG(ISEG)) THEN
            CALL TEMA_CMP(ISEG,CMP)
            CALL TEMA_TO_RSEG(CMP,ISEG,IROW)
            CALL TEMA_TO_RPNT(ISEG,IROW)
            CALL TEMA_TO_RHITB(ISEG,IROW)
         ENDIF
      ENDDO

      RETURN
      END


      SUBROUTINE TEMA_CMP(ISEG,CMP)

      IMPLICIT NONE
      INTEGER ISEG              ! segment index [in]
      INTEGER CMP               ! component bits [out]

#include "tema/TEMA_RSEG.fi"
#include "tema/TEMA_HITS.fi"
#include "tema/TEMA_LAY.fi"
#include "arte/RSEG_cmp.fi"
      INTEGER I, K

      CMP=IOR(RSEGC_PATT,rsegc_bit15)
      DO I=IP_SEG(ISEG-1)+1,IP_SEG(ISEG)
         K=INDIK(I)
         IF(IK(K).EQ.ISEG) THEN
            IF(LAY(K).LE.NLAY_OTR) THEN
               CMP=IOR(CMP,RSEGC_WCH)
            ELSE
               CMP=IOR(CMP,RSEGC_MSG)
            ENDIF
         ENDIF
      ENDDO
      RETURN
      END



      SUBROUTINE TEMA_TO_RSEG(CMP,K,IROW)

      IMPLICIT NONE
      INTEGER CMP, K, IROW      ! component [in], index [in], row RSEG [out]

#include "tema/TEMA_RSEG.fi"
#include "arte/Arte.fi"
#include "auto/RSEG.fi"
      INTEGER I
#include "arte/Arte.ff"
#include "auto/RSEG.ff"


      CALL MMBOOK(JRSEG,1)
      IROW=NRSEG()
      Q(QRSEG_ZF_L())=SEG_RF(3,K)
      Q(QRSEG_XF_L())=SEG_RF(1,K)
      Q(QRSEG_YF_L())=SEG_RF(2,K)
      Q(QRSEG_TXF_L())=SEG_S(1,K)
      Q(QRSEG_TYF_L())=SEG_S(2,K)
      Q(QRSEG_PF_L())=SEG_PF(K)
      DO I=1,MIN(M_COV,NRSEG_CVF)
         Q(QRSEG_CVF_L(I))=SEG_CVF(I,K)
      ENDDO
      IF(M_COV.LT.NRSEG_CVF) Q(QRSEG_CVF_L(NRSEG_CVF))=1.738
      Q(QRSEG_ZE_L())=SEG_RE(3,K)
      Q(QRSEG_XE_L())=SEG_RE(1,K)
      Q(QRSEG_YE_L())=SEG_RE(2,K)
      Q(QRSEG_TXE_L())=SEG_S(1,K)
      Q(QRSEG_TYE_L())=SEG_S(2,K)
      Q(QRSEG_PE_L())=SEG_PF(K)
      DO I=1,MIN(M_COV,NRSEG_CVE)
         Q(QRSEG_CVE_L(I))=SEG_CVE(I,K)
      ENDDO
      IF(M_COV.LT.NRSEG_CVE) Q(QRSEG_CVE_L(NRSEG_CVE))=1.738
      Q(QRSEG_CHI_L())=SEG_HI2(K)
      IQ(IQRSEG_FIT_L())=0
      IQ(IQRSEG_CMP_L())=CMP
      IQ(IQRSEG_ERR_L())=0
      IQ(IQRSEG_NHIT_L())=NDF_SEG(K)+4
      IQ(IQRSEG_NPAR_L())=4

      RETURN
      END



      SUBROUTINE TEMA_TO_RPNT(K,IROW)

      IMPLICIT NONE
      INTEGER K, IROW           ! segment index [in], row RSEG [in]

#include "tema/TEMA_RSEG.fi"
#include "arte/Arte.fi"
#include "auto/RPNT.fi"
      INTEGER I, IR
#include "arte/Arte.ff"
#include "auto/RPNT.ff"


      CALL MMBOOK(JRPNT,1)
      IR=NRPNT()
      Q(QRPNT_ZF_L())=SEG_RF(3,K)
      Q(QRPNT_XF_L())=SEG_RF(1,K)
      Q(QRPNT_YF_L())=SEG_RF(2,K)
      Q(QRPNT_TXF_L())=SEG_S(1,K)
      Q(QRPNT_TYF_L())=SEG_S(2,K)
      Q(QRPNT_PF_L())=SEG_PF(K)
      DO I=1,MIN(M_COV,NRPNT_CVF)
         Q(QRPNT_CVF_L(I))=SEG_CVF(I,K)
      ENDDO
      IF(M_COV.LT.NRPNT_CVF) Q(QRPNT_CVF_L(NRPNT_CVF))=1.738
      CALL MMBREL(JRSRP,IROW,IR)

      CALL MMBOOK(JRPNT,1)
      IR=NRPNT()
      Q(QRPNT_ZF_L())=SEG_RE(3,K)
      Q(QRPNT_XF_L())=SEG_RE(1,K)
      Q(QRPNT_YF_L())=SEG_RE(2,K)
      Q(QRPNT_TXF_L())=SEG_S(1,K)
      Q(QRPNT_TYF_L())=SEG_S(2,K)
      Q(QRPNT_PF_L())=SEG_PF(K)
      DO I=1,MIN(M_COV,NRPNT_CVF)
         Q(QRPNT_CVF_L(I))=SEG_CVE(I,K)
      ENDDO
      IF(M_COV.LT.NRPNT_CVF) Q(QRPNT_CVF_L(NRPNT_CVF))=1.738
      CALL MMBREL(JRSRP,IROW,IR)

      RETURN
      END



      SUBROUTINE TEMA_TO_RHITB(ISEG,IROW)

      IMPLICIT NONE
      INTEGER ISEG, IROW           ! segment index [in], row RSEG [in]

#include "tema/TEMA_RSEG.fi"
#include "tema/TEMA_HITS.fi"
#include "arte/Arte.fi"
#include "auto/RHIT.fi"
#include "auto/HITB.fi"
      INTEGER I, K, N, IR
      integer NSIZ
      PARAMETER (NSIZ=1024)
      REAL XH(NSIZ), YH(NSIZ), ZH(NSIZ), QH(NSIZ)
      INTEGER IH(NSIZ), II(NSIZ)
      INTEGER IER1
      SAVE IER1
#include "arte/Arte.ff"
#include "auto/RHIT.ff"
#include "auto/HITB.ff"

      N=0
      DO I=IP_SEG(ISEG-1)+1,IP_SEG(ISEG)
         K=INDIK(I)
         IF(IK(K).EQ.ISEG) THEN
            N=N+1
            IF(N.LE.NSIZ) THEN
               XH(N)=RPHIT(1,K)
               YH(N)=RPHIT(2,K)
               ZH(N)=RPHIT(3,K)
               QH(N)=QHIT(K)
               IH(N)=HITB_ROW(K)
            ENDIF
         ENDIF
      ENDDO
      IF(N.GT.NSIZ) THEN
         CALL MEPRIC(IER1,10,'TEMA: tema_to_rhitb_, N > NSIZ (bug?)')
      ENDIF
      N=MIN(N,NSIZ)
      CALL SORTZV(ZH,II,N,1,1,0)
      DO I=1,N
         K=II(I)
         CALL MMBOOK(JRHIT,1)
         IR=NRHIT()
         Q(QRHIT_X_L())=XH(K)
         Q(QRHIT_Y_L())=YH(K)
         Q(QRHIT_TX_L())=SEG_S(1,ISEG)
         Q(QRHIT_TY_L())=SEG_S(2,ISEG)
         Q(QRHIT_P_L())=SEG_PF(ISEG)
         Q(QRHIT_Q_L())=QH(K)
         CALL MMBREL(JHIRH,IH(K),IR)
         CALL MMBREL(JRSRH,IROW,IR)
         CALL MMBREL(JRSHI,IROW,IH(K))
      ENDDO

      RETURN
      END


