#ifndef _L3_MONITOR_HH_
#define _L3_MONITOR_HH_
// *****************************************************************************
//
// source:    L3_Monitor.hh
//
// type:      include file
//
// created:   06 Dec 1999
//
// authors:   Stefan Scharein, Ullrich Schwanke
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: scharein@ifh.de, schwanke@ifh.de
//
// changes:
//
// *****************************************************************************

#include "L3_Defines.hh"
#include <vector>

class L3_Event;
class L3_State;
class L3_Timer;
class L3_Track;
class L3_SpacePoint;
class L3_Vertex;

#ifndef L3_NO_RHP
#include "L3_RHP.hh"

class L3_Monitor {
public:
  L3_Monitor();
  L3_Monitor(const L3_Monitor&);
  L3_Monitor& operator = (const L3_Monitor&);
  void init();
  void put(const L3_Event&);
  void put(const L3_State&);
  void put(const L3_Timer&);
  void stop();
private:
  void put(vector<L3_Track> TrackList);
  void put(vector<L3_SpacePoint> PointList);
  void put(vector<L3_Vertex> PrimVtxList);
};

#endif
#endif
