*CMZ :          11/11/96  16.08.38  by  T. Oest
*-- Author :    T. Oest   30/05/96

      SUBROUTINE RKDV02(UPDATE, H, EC, RKD)

************************************************************************
*
* Description: returns the derivatives for fixed POUT(1)
*              fast method
*
* Called from:
*
* External references:
*
* Argument in/out description
* UPDATE   in      = .TRUE. the derivatives will be updated
* H        in      step size
* FAC      in      Qc/p*sign(cos gamma)
* RKD      in/out  derivatives d POUT / d PIN
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

      DOUBLE PRECISION H, RKD(6,6)
      LOGICAL          UPDATE
      DOUBLE PRECISION RKWORK(6,6), DKDP(6,6,6), RKCO(6,6)
      DOUBLE PRECISION SUM1, SUM6, EC, FAC, A
      INTEGER I, J, L, M, N, II, M1, M2


      DOUBLE PRECISION B(15), C(6), CST(6), PSTEPS(6,6), K(6,5)
      DOUBLE PRECISION BFIELD(6,3), FSTEPS(6,2)
      COMMON /CRKUT2/  PSTEPS, B, C, CST, K, BFIELD, FSTEPS

#include "arte/Arte.ff"

      DATA DKDP /216*0.0D0/
************************************************************************
* get DKDP
************************************************************************

      II  = 0
      FAC = PSTEPS(1,6)*EC
      DO I=1,6

c dkdp =0  for J=6
       DKDP(I,2,1) = -PSTEPS(I,4)
       DKDP(I,3,1) = -PSTEPS(I,5)
       DKDP(I,4,1) = -K(I,4)/H

       DKDP(I,2,6) = 0.0D0


       DKDP(I,4,6) = EC * H * FSTEPS(I,1)


       IF (I.GT.1) THEN

         SUM1 = 0.0D0
         SUM6 = 0.0D0
         II  = (I-1)*(I-2)/2
         DO N=1,I-1
          II = II + 1
          SUM1 = SUM1 + B(II) * DKDP(N,4,1)
          SUM6 = SUM6 + B(II) * DKDP(N,4,6)
         ENDDO

         DKDP(I,2,1) = DKDP(I,2,1) + H * SUM1
         DKDP(I,2,6) = H * SUM6

       ENDIF

       ENDDO
************************************************************************
* derivartive matrix for this step
************************************************************************
       DO I=1,6
       DO J=1,6
        RKWORK(I,J) = 0.0D0
       ENDDO
        RKWORK(I,I) = 1.0D0
       ENDDO


c DKDP=0 for i=6

       RKWORK(1,1) = 0.0D0
       RKWORK(2,4) = H
       RKWORK(3,5) = H

       DO L=1,6
        RKWORK(2,1) = RKWORK(2,1) + C(L) * DKDP(L,2,1)
        RKWORK(3,1) = RKWORK(3,1) + C(L) * DKDP(L,3,1)
        RKWORK(4,1) = RKWORK(4,1) + C(L) * DKDP(L,4,1)

        RKWORK(2,6) = RKWORK(2,6) + C(L) * DKDP(L,2,6)

        RKWORK(4,6) = RKWORK(4,6) + C(L) * DKDP(L,4,6)
       ENDDO

************************************************************************
* UPDATE MATRIX
************************************************************************

       IF (UPDATE) THEN

        DO I=1,6
        DO J=1,6
         RKCO(I,J) = RKD(I,J)
         RKD (I,J) = 0.0D0
        ENDDO
        ENDDO

        RKD(2,2) = 1.0D0
        RKD(3,3) = 1.0D0
        RKD(4,4) = 1.0D0
        RKD(5,5) = 1.0D0
        RKD(6,6) = 1.0D0

        RKD(2,1) = RKCO(2,1) + RKWORK(2,4) * RKCO(4,1)
        RKD(2,4) = RKCO(2,4) + RKWORK(2,4)
        RKD(2,6) = RKCO(2,6) + RKWORK(2,4) * RKCO(4,6) + RKWORK(2,6)

        RKD(3,1) = RKCO(3,1)
        RKD(3,5) = RKCO(3,5) + RKWORK(3,5)

        RKD(4,1) = RKCO(4,1)
        RKD(4,6) = RKCO(4,6) + RKWORK(4,6)


       ELSE

        DO I=1,6
        DO J=1,6
         RKD(I,J) = RKWORK(I,J)
        ENDDO
        ENDDO

       ENDIF




      END

************************************************************************
* End of RKDERI
************************************************************************
