*CMZ :          30/09/96  14.55.43  by  T. Oest
*-- Author :    T. Oest   24/09/96

      SUBROUTINE V0STRT(TRK1, TRK2, Z1, SZ1, CHI1, Z2, SZ2, CHI2,
     +                  IERROR)

************************************************************************
*
* Description:
*
* Called from:
*
* External references:
*
* Argument in/out description
* TRK1     in     first track
* TRK2     in     second track
* Z        out    start value for z
* SZ       out    uncertainty on z
* CHI      out    chi2 of combination
* IRET     out    >=0 ok
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/EV.fi"

      INTEGER          TRK1, TRK2, IRET, IERROR
      DOUBLE PRECISION Z, SZ

      DOUBLE PRECISION Z1, SZ1, Z2, SZ2, ZY, SY, ZX1, ZX2, SX1, SX2
      DOUBLE PRECISION CHI1, CHI2
      REAL*4           SOLUT, ZMAG


#include "arte/Arte.ff"
#include "auto/EV.ff"


      DATA ZMAG /200./
C-----------------------------------------------------------------------
C  initialization
C-----------------------------------------------------------------------
      IERROR = 0
      SX1    = -1.0
      SX2    = -1.0
      CHI1   = -1.0
      CHI2   = -1.0
C-----------------------------------------------------------------------
C  in front of the magnet
C-----------------------------------------------------------------------
      IF (FRTRA_ZF(TRK1).LE.ZMAG .OR. FRTRA_ZF(TRK2).LE.ZMAG ) THEN
       CALL V0ST1(TRK1, TRK2, Z1, SZ1, CHI1, IRET)
       IF (IRET.LT.0) IERROR = -1
       GOTO 9000
      ENDIF
C-----------------------------------------------------------------------
C  intersection in xz
C-----------------------------------------------------------------------
      SOLUT  =  1.0
      CALL V0XZ(SOLUT, TRK1, TRK2, ZX1, SX1, IRET)
c      print*,'***********************************************'
c      print*,' intersection in xz: '
c      print*,zX1,sX1,iret
      IF (IRET.LT.0) THEN
       SOLUT  = -1.0
       CALL V0XZ(SOLUT, TRK1, TRK2, ZX1, SX1, IRET)
c       print*,'***********************************************'
c       print*,' intersection in xz: '
c       print*,ZX1,sX1,iret
       IF (IRET.LT.0) SX1 = -1.
      ELSEIF (IRET.EQ.0) THEN
       SOLUT  = -1.0
       CALL V0XZ(SOLUT, TRK1, TRK2, ZX2, SX2, IRET)
c       print*,'***********************************************'
c       print*,' intersection in xz: '
c       print*,ZX2,sX2,iret
       IF (IRET.LT.0) SX2 = -1.
      ENDIF

C-----------------------------------------------------------------------
C  intersection in yz
C-----------------------------------------------------------------------
      CALL V0YZ(TRK1, TRK2, ZY, SY, IRET)
c      print*,''
c      print*,'***********************************************'
c      print*,' intersection in YZ: '
c      print*,zy,sy,iret
      IF (IRET.LT.0) SY = -1.

C-----------------------------------------------------------------------
C combine z values
C-----------------------------------------------------------------------
      SZ1 = SX1
      SZ2 = SX2

      IF (SX1.LE.0.0 .AND. SX2.LE.0.0) THEN
       Z1   = ZY
       SZ1  = SY
       CHI1 = 0.0
      ELSE

       IF (SY.GT.0.0) THEN
        IF (SX1.GT.0.0) THEN
         Z1   = ( ZX1*SY**2 + ZY*SX1**2 ) / (SY**2 + SX1**2)
         SZ1  = ( 1./SX1**2 + 1./SY**2 )**(-0.5)
         CHI1 = ((Z1-ZX1)/SX1)**2 + ((Z1-ZY)/SY)**2
        ENDIF
        IF (SX2.GT.0.0) THEN
         Z2   = ( ZX2*SY**2 + ZY*SX2**2 ) / (SY**2 + SX2**2)
         SZ2  = ( 1./SX2**2 + 1./SY**2 )**(-0.5)
         CHI2 = ((Z2-ZX2)/SX2)**2 + ((Z2-ZY)/SY)**2
        ENDIF
       ELSE
        Z1   = ZX1
        Z2   = ZX2
        CHI1 = 0.0
        CHI2 = 0.0
       ENDIF
      ENDIF

      IF (SZ1.LE.0.0 .AND. SZ2. LE. 0.0) THEN
       IERROR = -2
       GOTO 9000
      ENDIF
C-----------------------------------------------------------------------
C chose best solution
C-----------------------------------------------------------------------
      IF ((CHI2.LT.CHI1 .AND. CHI2.GE.0.0) .OR. SZ1.LT.0.0) THEN
       Z   = Z1
       SZ  = SZ1
       SX1 = CHI1
       Z1  = Z2
       SZ1 = SZ2
       CHI1= CHI2
       Z2  = Z
       SZ2 = SZ
       CHI2= SX1
      ENDIF
c      print*,''
c      print*,'***********************************************'
c      print*,' combined value: '
c      print*,z1,sz1,CHI1
c      print*,z2,sz2,CHI2
C-----------------------------------------------------------------------
C  the end
C-----------------------------------------------------------------------
 9000 END

************************************************************************
* End of V0STRT
************************************************************************
